*DK celcntr
      subroutine celcntr(xc,xn,id,nt)
 
c     This routine computes the coordinates of the centers of
c     the triangles of diamond id from vertex coordinates xn.
 
      real xn(0:nt,nt+1,10,3), xc(nt+1,0:nt,2,3)
 
      do 10 i1=1,nt
      do 10 i2=1,nt
      x1 = xn(i1  ,i2,id,1) + xn(i1-1,i2+1,id,1)
     &   + xn(i1-1,i2,id,1)
      x2 = xn(i1  ,i2,id,2) + xn(i1-1,i2+1,id,2)
     &   + xn(i1-1,i2,id,2)
      x3 = xn(i1  ,i2,id,3) + xn(i1-1,i2+1,id,3)
     &   + xn(i1-1,i2,id,3)
      xx = 1./sqrt((x1**2 + x2**2) + x3**2)
      xc(i1,i2,1,1) = xx*x1
      xc(i1,i2,1,2) = xx*x2
      xc(i1,i2,1,3) = xx*x3
      x1 = xn(i1  ,i2,id,1) + xn(i1-1,i2+1,id,1)
     &   + xn(i1,i2+1,id,1)
      x2 = xn(i1  ,i2,id,2) + xn(i1-1,i2+1,id,2)
     &   + xn(i1,i2+1,id,2)
      x3 = xn(i1  ,i2,id,3) + xn(i1-1,i2+1,id,3)
     &   + xn(i1,i2+1,id,3)
      xx = 1./sqrt((x1**2 + x2**2) + x3**2)
      xc(i1,i2,2,1) = xx*x1
      xc(i1,i2,2,2) = xx*x2
      xc(i1,i2,2,3) = xx*x3
 10   continue
 
      idul = mod(id+3,5) + 1
      if(id.le.5) then
         idll = idul + 5
      else
         idul = idul + 5
         idll = id   - 5
      endif
 
      do 20 i=1,nt
      x1 = xn(1,i+1,idul,1) + xn(i,1,id,1) + xn(1,i,idul,1)
      x2 = xn(1,i+1,idul,2) + xn(i,1,id,2) + xn(1,i,idul,2)
      x3 = xn(1,i+1,idul,3) + xn(i,1,id,3) + xn(1,i,idul,3)
      xx = 1./sqrt((x1**2 + x2**2) + x3**2)
      xc(i+1,0,1,1) = xx*x1
      xc(i+1,0,1,2) = xx*x2
      xc(i+1,0,1,3) = xx*x3
      x1 = xn(1,i,idul,1) + xn(i-1,1,id,1) + xn(i,1,id,1)
      x2 = xn(1,i,idul,2) + xn(i-1,1,id,2) + xn(i,1,id,2)
      x3 = xn(1,i,idul,3) + xn(i-1,1,id,3) + xn(i,1,id,3)
      xx = 1./sqrt((x1**2 + x2**2) + x3**2)
      xc(i,0,2,1) = xx*x1
      xc(i,0,2,2) = xx*x2
      xc(i,0,2,3) = xx*x3
      x1 = xn(nt+1-i,nt,idll,1) + xn(nt,i+1,id,1) + xn(nt,i,id,1)
      x2 = xn(nt+1-i,nt,idll,2) + xn(nt,i+1,id,2) + xn(nt,i,id,2)
      x3 = xn(nt+1-i,nt,idll,3) + xn(nt,i+1,id,3) + xn(nt,i,id,3)
      xx = 1./sqrt((x1**2 + x2**2) + x3**2)
      xc(nt+1,i,1,1) = xx*x1
      xc(nt+1,i,1,2) = xx*x2
      xc(nt+1,i,1,3) = xx*x3
      x1 = xn(nt+1-i,nt,idll,1) + xn(nt,i+1,id,1) + xn(nt-i,nt,idll,1)
      x2 = xn(nt+1-i,nt,idll,2) + xn(nt,i+1,id,2) + xn(nt-i,nt,idll,2)
      x3 = xn(nt+1-i,nt,idll,3) + xn(nt,i+1,id,3) + xn(nt-i,nt,idll,3)
      xx = 1./sqrt((x1**2 + x2**2) + x3**2)
      xc(nt+1,i,2,1) = xx*x1
      xc(nt+1,i,2,2) = xx*x2
      xc(nt+1,i,2,3) = xx*x3
 20   continue
      xc(nt+1,0,2,1) = xc(nt+1,0,1,1)
      xc(nt+1,0,2,2) = xc(nt+1,0,1,2)
      xc(nt+1,0,2,3) = xc(nt+1,0,1,3)
 
      end
*dk circle
      subroutine circle(x,y,r)
 
c     This routine draws a circle of radius r centered at (x,y).
 
      nphi = 100
      dphi = 2.*3.141592653589793/real(nphi)
 
      call gmova2(x + r,y)
 
      do 10 i=1,nphi
 
      xx = x + r*cos(dphi*real(i))
      yy = y + r*sin(dphi*real(i))
 
      call glina2(xx,yy)
 
 10   continue
 
      end
*dk clrplt
      subroutine clrplt(s,xn,xc,p1,p2,e,ir,smin,smax,nt)
 
c     This routine generates a color plot of the scalar field s
c     with blue at the low end and red at the high end of the
c     range of s.
 
      real s(0:nt,nt+1,10,*), xn(*), xc(*)
      real p1(3), p2(3), e(3), x(6), y(6)
 
      call circle(0.,0.,1.)
      call equator(p1,p2,e)
 
      ssum = s(0,1,1,ir) + s(0,1,6,ir)
      smin = min(s(0,1,1,ir), s(0,1,6,ir))
      smax = max(s(0,1,1,ir), s(0,1,6,ir))
      do 10 id=1,10
      do 10 i2=1,nt
      do 10 i1=1,nt
      ssum = ssum + s(i1,i2,id,ir)
      smin = min(smin,s(i1,i2,id,ir))
      smax = max(smax,s(i1,i2,id,ir))
 10   continue
      savg = ssum/(10*nt*nt+2)
 
      if(smax-smin.gt.0.) then
         call legend(-1.9,-0.5,1.0,smin,smax)
         sf = 1.0/(smax-smin)
      else
         sf = 1.0
      endif
 
      third = 1./3.
      do 20 id=1,10
 
      call celcntr(xc,xn,id,nt)
 
      do 20 i2=1,nt
      do 20 i1=1,nt
 
      if(dotpr(e,xn,i1,i2,id,nt) .gt. 0.) then
 
         c = sf*(s(i1,i2,id,ir) - smin)
         c = min(1., max(0., c))
         call gclr(c)
 
         x(1) = dotprd(p1,xc,i1  ,i2  ,2,nt)
         x(2) = dotprd(p1,xc,i1  ,i2  ,1,nt)
         x(3) = dotprd(p1,xc,i1  ,i2-1,2,nt)
         x(4) = dotprd(p1,xc,i1+1,i2-1,1,nt)
         x(5) = dotprd(p1,xc,i1+1,i2-1,2,nt)
         x(6) = dotprd(p1,xc,i1+1,i2  ,1,nt)
         y(1) = dotprd(p2,xc,i1  ,i2  ,2,nt)
         y(2) = dotprd(p2,xc,i1  ,i2  ,1,nt)
         y(3) = dotprd(p2,xc,i1  ,i2-1,2,nt)
         y(4) = dotprd(p2,xc,i1+1,i2-1,1,nt)
         y(5) = dotprd(p2,xc,i1+1,i2-1,2,nt)
         y(6) = dotprd(p2,xc,i1+1,i2  ,1,nt)
         call gplga2(x,y,6)
 
      endif
 
 20   continue
 
      if(dotpr(e,xn,0,1,1,nt) .gt. 0.) then
         c = sf*(s(0,1,1,ir) - smin)
         c = min(1., max(0., c))
         call gclr(c)
 
         x0 = dotpr(p1,xn,0,1,1,nt)
         x1 = dotpr(p1,xn,1,1,1,nt)
         x2 = dotpr(p1,xn,1,1,2,nt)
         x3 = dotpr(p1,xn,1,1,3,nt)
         x4 = dotpr(p1,xn,1,1,4,nt)
         x5 = dotpr(p1,xn,1,1,5,nt)
         y0 = dotpr(p2,xn,0,1,1,nt)
         y1 = dotpr(p2,xn,1,1,1,nt)
         y2 = dotpr(p2,xn,1,1,2,nt)
         y3 = dotpr(p2,xn,1,1,3,nt)
         y4 = dotpr(p2,xn,1,1,4,nt)
         y5 = dotpr(p2,xn,1,1,5,nt)
         x(1) = third*(x0 + x1 + x2)
         x(2) = third*(x0 + x2 + x3)
         x(3) = third*(x0 + x3 + x4)
         x(4) = third*(x0 + x4 + x5)
         x(5) = third*(x0 + x5 + x1)
         y(1) = third*(y0 + y1 + y2)
         y(2) = third*(y0 + y2 + y3)
         y(3) = third*(y0 + y3 + y4)
         y(4) = third*(y0 + y4 + y5)
         y(5) = third*(y0 + y5 + y1)
         call gplga2(x,y,5)
      endif
 
      if(dotpr(e,xn,0,1,6,nt) .gt. 0.) then
         c = sf*(s(0,1,6,ir) - smin)
         c = min(1., max(0., c))
         call gclr(c)
 
         x0 = dotpr(p1,xn,0,1,6,nt)
         x1 = dotpr(p1,xn,1,1,6,nt)
         x2 = dotpr(p1,xn,1,1,7,nt)
         x3 = dotpr(p1,xn,1,1,8,nt)
         x4 = dotpr(p1,xn,1,1,9,nt)
         x5 = dotpr(p1,xn,1,1,10,nt)
         y0 = dotpr(p2,xn,0,1,6,nt)
         y1 = dotpr(p2,xn,1,1,6,nt)
         y2 = dotpr(p2,xn,1,1,7,nt)
         y3 = dotpr(p2,xn,1,1,8,nt)
         y4 = dotpr(p2,xn,1,1,9,nt)
         y5 = dotpr(p2,xn,1,1,10,nt)
         x(1) = third*(x0 + x1 + x2)
         x(2) = third*(x0 + x2 + x3)
         x(3) = third*(x0 + x3 + x4)
         x(4) = third*(x0 + x4 + x5)
         x(5) = third*(x0 + x5 + x1)
         y(1) = third*(y0 + y1 + y2)
         y(2) = third*(y0 + y2 + y3)
         y(3) = third*(y0 + y3 + y4)
         y(4) = third*(y0 + y4 + y5)
         y(5) = third*(y0 + y5 + y1)
         call gplga2(x,y,5)
      endif
 
      call grgb(1.,1.,1.)
 
      end
*dk contour
      subroutine contour(s,xn,xv,p1,p2,e,ir,ncon,smin,smax,nt)
 
c     This routine generates a contour plot of the scalar field s
c     for layer ir in orthographic projection.
 
      real  s(0:nt,nt+1,10,*), xn(0:nt,nt+1,10,3)
      real xv(0:nt,nt+1,2), p1(3), p2(3), e(3), x(3), rcon(21)
 
      call circle(0.,0.,1.)
      call equator(p1,p2,e)
      call gtwdth(0.045)
 
      smin = min(s(1,1,1,ir), s(1,1,6,ir))
      smax = max(s(1,1,1,ir), s(1,1,6,ir))
      do 10 id=1,10
      do 10 i2=1,nt
      do 10 i1=1,nt
      smin = min(smin,s(i1,i2,id,ir))
      smax = max(smax,s(i1,i2,id,ir))
 10   continue
 
      if(ncon.gt.3) call cntrlbl(smin,smax)
 
      dr   = (smax - smin)/(ncon - 1)
      do 20 i=1,ncon
      rcon(i) = smin + (i-1)*dr
 20   continue
      rcon(1) = rcon(1) + 0.00001*dr
 
      do 50 id=1,10
 
      do 40 i2=1,nt+1
      do 40 i1=0,nt
      do 30 j=1,3
      x(j) = xn(i1,i2,id,j)
 30   continue
      if(dprd(x,e) .gt. 0.10) then
         xv(i1,i2,1) = dprd(x,p1)
         xv(i1,i2,2) = dprd(x,p2)
      else
         xv(i1,i2,1) = 1.e35
         xv(i1,i2,2) = 1.e35
      endif
 40   continue
 
      call kontour(s,xv,rcon,id,ir,ncon,1,nt)
 
 50   continue
 
      call grgb(1.,1.,1.)
      call gtwdth(0.045)
 
      end
*dk cntrlbl
      subroutine cntrlbl(smin,smax)
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /clbl/ tnorm, bnorm
      character str6*6, str9*9
 
      call gmova2(-1.9, 0.30)
      call gwidth(0.25)
 
      if(ispec/2.eq.1.or.ispec/2.eq.4) then
         call gtext("TEMPERATURE",11)
      elseif(ispec.eq.4 .or. ispec.eq.5) then
         call gtext("   PRESSURE",11)
      elseif(ispec.eq.6 .or. ispec.eq.7) then
         call gtext("LOG VISCOSITY",13)
      elseif(ispec/2.eq.5) then
         call gtext("GRAVITY ANOMALY",15)
      elseif(ispec/2.eq.6) then
         call gtext("EQUIPOTENTIAL",13)
      elseif(ispec/2.eq.7) then
         call gtext("TOPOGRAPHY",10)
      elseif(ispec/2.eq.8) then
         call gtext("RADIAL VELOCITY",15)
      elseif(ispec/2.eq.9) then
         call gtext("SHEAR HEATING",13)
      endif
 
      wd =  0.045
      x0 = -1.90
      y0 =  0.20
      dy =  0.10
 
      call gmova2(x0,y0)
      call gtext("CONTOUR VALUES",14)
 
      y  = y0 - 5.8*dy
      x  = x0 + 0.05
      call gclr(0.0)
      call gmark(x,y         ,wd,'L')
      call gclr(0.2)
      call gmark(x,y + 1.0*dy,wd,'2')
      call gclr(0.4)
      call gmark(x,y + 2.0*dy,wd,'4')
      call gclr(0.6)
      call gmark(x,y + 3.0*dy,wd,'6')
      call gclr(0.8)
      call gmark(x,y + 4.0*dy,wd,'8')
      call gclr(1.0)
      call gmark(x,y + 5.0*dy,wd,'H')
      call grgb(1.,1.,1.)
 
      ds = 0.2*(smax - smin)
      s  = smax + ds
      y  = y0
      it = 0
      if((ispec/2.eq.1.or.ispec/2.eq.4) .and. smax.gt.2.) it = 1
 
      do 10 i=1,6
      s  = s - ds
      y  = y - dy
      call gmova2(x0,y)
      call gtext("   --",5)
      if(it.eq.1) write(str6,'(i6)') int(s)
      if(it.ne.1) write(str9,'(1pe9.2)') s
      if(it.eq.1) call gtext(str6,6)
      if(it.eq.1) call gtext(' K',2)
      if(it.ne.1) call gtext(str9,9)
 10   continue
 
      call gwidth(0.)
 
      end
*dk dotprd
      function dotprd(e,xc,i1,i2,ie,nt)
 
c     This routine computes the dot product of the vector e
c     with the cell center coordinate array xc for cell (i1,i2,ie).
 
      real xc(nt+1,0:nt,2,3), e(3)
 
      dotprd = e(1)*xc(i1,i2,ie,1) + e(2)*xc(i1,i2,ie,2)
     &       + e(3)*xc(i1,i2,ie,3)
 
      end
*dk drawif
      subroutine drawif(x,y,se,nn)
 
c     This routine causes lines to be drawn to connect successive
c     points (x(i),y(i)) provided se(i) is nonnegative.
 
      real x(nn), y(nn), se(nn)
 
      call gmova2(x(1),y(1))
 
      do 10 i=2,nn
 
      if(se(i).ge.0.) then
         call glina2(x(i),y(i))
      else
         call gmova2(x(i),y(i))
      endif
 
 10   continue
 
      end
*dk eborder
      subroutine eborder
 
c     This routine draws the lines of constant latitude and
c     longitude on the equal area plot.
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      wd   = 0.025
      pi   = 3.141592653589793
      nphi = 100
      dphi = 2.*pi/nphi
 
c     Draw border.
 
      call gmova2(0.0, 0.5)
      do 10 i=1,nphi
      xx =     sin(dphi*real(i))
      yy = 0.5*cos(dphi*real(i))
      call glina2(xx,yy)
 10   continue
 
c     Draw meridians spaced 45 degrees apart.
 
      do 30 k=1,7
      hflong = 0.125*pi*(k - 4)
      chlong = cos(hflong)
      shlong = sin(hflong)
      call gmova2(0.0,0.5)
      do 20 i=1,nphi
      colat  = i*dphi
      scolat = sin(colat)
      rdenom = 1./sqrt(1. + abs(scolat*chlong))
      xx     = rdenom*scolat*shlong
      yy     = rdenom*0.5*cos(colat)
      call glina2(xx,yy)
 20   continue
 30   continue
 
c     Draw parallels spaced 45 degrees apart.
 
      do 50 k=1,3
      colat  = 0.25*pi*k
      ccolat = cos(colat)
      scolat = sin(colat)
      call gmova2(-scolat,0.5*ccolat)
      do 40 i=1,nphi
      hflong = 0.5*(i*dphi - pi)
      rdenom = 1./sqrt(1. + abs(scolat*cos(hflong)))
      xx     = rdenom*scolat*sin(hflong)
      yy     = rdenom*0.5*ccolat
      call glina2(xx,yy)
 40   continue
 50   continue
 
      if(ieqar.eq.1) then
         call gmova2(-0.5*wd,-0.5-1.5*wd)
         call gtext("0",1)
      else
         call gmova2(-1.5*wd,-0.5-1.5*wd)
         call gtext("180",3)
      endif
 
      end
*dk eclrplt
      subroutine eclrplt(s,xn,xc,ir,smin,smax,nt)
 
c     This routine generates a color plot in equal area projection
c     of the scalar field s with blue at the low end and red at
c     the high end of the range of s.
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      real s(0:nt,nt+1,10,*), xn(*), xc(nt+1,0:nt,2,3), w(6,3), x(6,2)
      common /clr1/ j1t(6), j2t(6), jet(6)
 
      ssum = s(0,1,1,ir) + s(0,1,6,ir)
      smin = min(s(0,1,1,ir), s(0,1,6,ir))
      smax = max(s(0,1,1,ir), s(0,1,6,ir))
      do 10 id=1,10
      do 10 i2=1,nt
      do 10 i1=1,nt
      ssum = ssum + s(i1,i2,id,ir)
      smin = min(smin, s(i1,i2,id,ir))
      smax = max(smax, s(i1,i2,id,ir))
 10   continue
      savg = ssum/(10*nt*nt+2)
      if(icptn.eq.0 .and. ir.eq.2 .and.
     &  (ispec/2.eq.1 .or. ispec/2.eq.4)) then
         smin =  500.
         smax = 2000.
      endif
 
      thrd = 1./3.
      pi   = 3.141592653589793
      sn   = 1.
      if(ieqar .eq. 2) sn = -1.
      sf   = 1.
      if(smax - smin .gt. 0.) sf = 1./(smax - smin)
 
      do 50 id=1,10
 
      call celcntr(xc,xn,id,nt)
 
      do 50 i2=1,nt
      do 50 i1=0,nt
      if(i1.eq.0 .and. i2.gt.1) go to 40
 
      c  = sf*(s(i1,i2,id,ir) - smin)
      c  = min(1., max(0., c))
      call gclr(c)
 
      do 20 i=1,6
      j1 = i1 + j1t(i)
      j2 = i2 + j2t(i)
      je =      jet(i)
      w(i,1) = 0.5*atan2(sn*xc(j1,j2,je,2), sn*xc(j1,j2,je,1)+1.e-40)
      w(i,2) = sqrt(max(0., 1. - xc(j1,j2,je,3)**2))
      w(i,3) = xc(j1,j2,je,3)
 20   continue
      if(i1.eq.nt .and. i2.eq.1) then
         w(6,1) = w(5,1)
         w(6,2) = w(5,2)
         w(6,3) = w(5,3)
      endif
 
      if(i1.eq.0 .and. i2.eq.1) then
         aa = 1.
         if(id .ge. 6) aa = -1.
         w(2,1) = 0.
         w(3,1) = 0.
         w(4,1) = 0.
         w(5,1) = 0.
         w(2,2) = 0.
         w(3,2) = 0.
         w(4,2) = 0.
         w(5,2) = 0.
         w(2,3) = aa
         w(3,3) = aa
         w(4,3) = aa
         w(5,3) = aa
      endif
 
      do 30 i=1,6
      rdenom = 1./sqrt(1. + abs(w(i,2)*cos(w(i,1))))
      x(i,1) = rdenom*w(i,2)*sin(w(i,1))
      x(i,2) = rdenom*w(i,3)*0.5
 30   continue
 
      if(ieqar .eq. 1) then
         if(id.eq.4 .and. i2.eq.1) then
            x1 = x(1,1)
            x2 = x(2,1)
            x3 = x(3,1)
            x(1,1) =  w(1,2)
            x(2,1) =  w(2,2)
            x(3,1) =  w(3,2)
            y1 = x(1,2)
            y2 = x(2,2)
            y3 = x(3,2)
            x(1,2) =  0.5*w(1,3)
            x(2,2) =  0.5*w(2,3)
            x(3,2) =  0.5*w(3,3)
            call gplga2(x(1,1),x(1,2),6)
            x(1,1) = -abs(x1)
            x(2,1) = -abs(x2)
            x(3,1) = -abs(x3)
            x(4,1) = -w(4,2)
            x(5,1) = -w(5,2)
            x(6,1) = -w(6,2)
            x(1,2) =  y1
            x(2,2) =  y2
            x(3,2) =  y3
            x(4,2) =  0.5*w(4,3)
            x(5,2) =  0.5*w(5,3)
            x(6,2) =  0.5*w(6,3)
         elseif(id.eq.8 .and. i2-i1.eq.1) then
            x2 = x(2,1)
            x3 = x(3,1)
            x(1,1) =  w(1,2)
            x(2,1) =  w(2,2)
            x(3,1) =  w(3,2)
            x(4,1) =  w(4,2)
            y2 = x(2,2)
            y3 = x(3,2)
            x(1,2) =  0.5*w(1,3)
            x(2,2) =  0.5*w(2,3)
            x(3,2) =  0.5*w(3,3)
            x(4,2) =  0.5*w(4,3)
            call gplga2(x(1,1),x(1,2),6)
            x(2,1) = -abs(x2)
            x(3,1) = -abs(x3)
            x(1,1) = -w(1,2)
            x(4,1) = -w(4,2)
            x(5,1) = -w(5,2)
            x(6,1) = -w(6,2)
            x(2,2) =  y2
            x(3,2) =  y3
            x(1,2) =  0.5*w(1,3)
            x(4,2) =  0.5*w(4,3)
            x(5,2) =  0.5*w(5,3)
            x(6,2) =  0.5*w(6,3)
         elseif( id.eq.8 .and. i1-i2.eq.0) then
            x(2,1) =  abs(x(2,1))
            x(3,1) =  abs(x(3,1))
         elseif((id.eq.8 .and. i2-i1.eq.2) .or.
     &          (id.eq.4 .and. i1.eq.nt .and. i2.eq.2)) then
            x(5,1) = -abs(x(5,1))
            x(6,1) = -abs(x(6,1))
         elseif(id.eq.9 .and. i1.eq.1 .and. i2.eq.1) then
            x(4,1) = -abs(x(4,1))
            x(5,1) = -abs(x(5,1))
         elseif(id.eq.9 .and. i1.eq.0 .and. i2.eq.1) then
            x(6,1) = -abs(x(6,1))
         endif
      elseif(ieqar .eq. 2) then
         if(id.eq.6 .and. i2.eq.1) then
            x1 = x(1,1)
            x2 = x(2,1)
            x3 = x(3,1)
            x(1,1) =  w(1,2)
            x(2,1) =  w(2,2)
            x(3,1) =  w(3,2)
            y1 = x(1,2)
            y2 = x(2,2)
            y3 = x(3,2)
            x(1,2) =  0.5*w(1,3)
            x(2,2) =  0.5*w(2,3)
            x(3,2) =  0.5*w(3,3)
            call gplga2(x(1,1),x(1,2),6)
            x(1,1) =  x1
            if(i1.eq.nt+1) x(1,1) = -abs(x(1,1))
            x(2,1) = -abs(x2)
            x(3,1) = -abs(x3)
            x(4,1) = -w(4,2)
            x(5,1) = -w(5,2)
            x(6,1) = -w(6,2)
            x(1,2) =  y1
            x(2,2) =  y2
            x(3,2) =  y3
            x(4,2) =  0.5*w(4,3)
            x(5,2) =  0.5*w(5,3)
            x(6,2) =  0.5*w(6,3)
         elseif(id.eq.1 .and. i2-i1.eq.1) then
            x2 = x(2,1)
            x3 = x(3,1)
            x(1,1) =  w(1,2)
            x(2,1) =  w(2,2)
            x(3,1) =  w(3,2)
            x(4,1) =  w(4,2)
            y2 = x(2,2)
            y3 = x(3,2)
            x(1,2) =  0.5*w(1,3)
            x(2,2) =  0.5*w(2,3)
            x(3,2) =  0.5*w(3,3)
            x(4,2) =  0.5*w(4,3)
            call gplga2(x(1,1),x(1,2),6)
            if(i1.eq.1) then
               w(6,2) = x(6,1)
               w(6,3) = x(6,2)*2.
            endif
            x(2,1) = -abs(x2)
            x(3,1) = -abs(x3)
            x(1,1) = -w(1,2)
            x(4,1) = -w(4,2)
            x(5,1) = -w(5,2)
            x(6,1) = -w(6,2)
            x(2,2) =  y2
            x(3,2) =  y3
            x(1,2) =  0.5*w(1,3)
            x(4,2) =  0.5*w(4,3)
            x(5,2) =  0.5*w(5,3)
            x(6,2) =  0.5*w(6,3)
         elseif(id.eq.1 .and. (i2-i1).eq.0) then
            x(2,1) =  w(2,2)
            x(3,1) =  w(3,2)
         elseif(id.eq.1 .and. (i2-i1).eq.2) then
            x(5,1) = -abs(x(5,1))
            x(6,1) = -abs(x(6,1))
         elseif(id.eq.2 .and. i1.eq.1 .and. i2.eq.1) then
            x(4,1) = -abs(x(4,1))
            x(5,1) = -abs(x(5,1))
         elseif(id.eq.6 .and. i1.eq.nt .and. i2.eq.2) then
            x(5,1) = -abs(x(5,1))
            x(6,1) = -abs(x(6,1))
         endif
      endif
 
      call gplga2(x(1,1),x(1,2),6)
 
 40   continue
 50   continue
 
      call grgb(1.,1.,1.)
 
      end
*dk econtur
      subroutine econtur(s,xn,xv,ir,ncon,smin,smax,nt)
 
c     This routine generates a contour plot of the scalar field s
c     for layer ir in equal area projection.
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      real  s(0:nt,nt+1,10,*), xn(0:nt,nt+1,10,3)
      real xv(0:nt,nt+1,2), x(3), rcon(21)
 
      pi   = 3.141592653589793
      sn   = 1.
      if(ieqar .eq. 2) sn = -1.
      smin = min(s(0,1,1,ir), s(0,1,6,ir))
      smax = max(s(0,1,1,ir), s(0,1,6,ir))
      do 10 id=1,10
      do 10 i2=1,nt
      do 10 i1=1,nt
      smin = min(smin,s(i1,i2,id,ir))
      smax = max(smax,s(i1,i2,id,ir))
 10   continue
 
      dr   = (smax - smin)/(ncon - 1)
      do 20 i=1,ncon
      rcon(i) = smin + (i-1)*dr
 20   continue
      rcon(1) = rcon(1) + 0.00001*dr
 
      do 70 id=1,10
 
      do 40 i2=1,nt+1
      do 40 i1=0,nt
      do 30  j=1,3
      x(j) = xn(i1,i2,id,j)
 30   continue
      hflong = 0.5*atan2(sn*x(2) + 0.00001, sn*x(1))
      scolat = sqrt(1. - x(3)**2)
      rdenom = 1./sqrt(1. + abs(scolat*cos(hflong)))
      xv(i1,i2,1) = rdenom*scolat*sin(hflong)
      xv(i1,i2,2) = rdenom*0.5*x(3)
 40   continue
 
      if((ieqar.eq.1 .and. id.eq.8) .or.
     &   (ieqar.eq.2 .and. id.eq.1)) then
         call kontour(s,xv,rcon,id,ir,ncon,3,nt)
         itype = 4
      else
         itype = 2
      endif
 
      call kontour(s,xv,rcon,id,ir,ncon,itype,nt)
 
 70   continue
 
      call grgb(1.,1.,1.)
 
      end
*dk eframe
      subroutine eframe(titl,time,rshl,ir,smin,smax,vscale)
 
c     This routine draws a border around an equal area plot and writes
c     appropriate labels and captions on the plot.
 
      dimension rshl(*)
      character*8 titl(4,4)
      character str6*6, str9*9, str10*10
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      y0 = -0.560
      dy =  0.042
      wd =  0.025
      pi =  3.141592653589793
 
      call gtwdth(wd)
 
      if(iclr.eq.1 .and. ispec.gt.1)
     &   call legend(0.69,-0.80,0.40,smin,smax)
 
      call gwidth(0.25)
 
      call eborder
 
      x = -0.98
      y = y0 + dy
      do 10 i=1,4
      y = y - dy
      call gmova2(x,y)
      call gtext(titl(1,i),32)
 10   continue
 
      if(time.ge.0.) then
         y = y - dy
         call gmova2(x,y)
         call gtext("DEPTH  =",8)
         dep = rshl(1) - rshl(ir)
         if(iscl.ne.1) dep = 0.001*dep
         write(str10,'(1pe10.3)') dep
         call gtext(str10,10)
         if(iscl.ne.1) call gtext(" KM",3)
      endif
 
      if(time.gt.0.) then
         y = y - dy
         call gmova2(x,y)
         call gtext("TIME   =",8)
         time1 = time
         if(time .lt. 10.) time1 = time*365.25
         write(str10,'(1pe10.3)') time1
         call gtext(str10,10)
         if(iscl.ne.1 .and. time.ge.10.) call gtext(" YR",3)
         if(iscl.ne.1 .and. time.lt.10.) call gtext(" DAYS",5)
      endif
 
      if(vscale.ne.0.) then
         y = y - dy
         call gmova2(x,y)
         if(vscale.lt.1.e-5.or.iscl.eq.1) then
            call gtext("MAXIMUM VELOCITY =",18)
            vscl = 3.1558e9*vscale
            if(iscl .eq. 1) vscl = vscale
            write(str10,'(1pe10.3)') vscl
            call gtext(str10,10)
            if(iscl.ne.1) call gtext(" CM/YR",6)
         else
            call gtext("MAXIMUM VELOCITY =",18)
            write(str10,'(1pe10.3)') vscale
            call gtext(str10,10)
            if(iscl.ne.1) call gtext(" M/SEC",6)
         endif
      endif
 
      if(iclr.ne.1 .and. ispec.ne.1) then
         x  = 0.25
         y  = y0
         call gmova2(x,y)
         if(ispec/2.eq.1 .or. ispec/2.eq.4) then
            call gtext(" TEMPERATURE CONTOUR VALUES",27)
         elseif(ispec/2.eq.8) then
            call gtext("   RADIAL VELOCITY (M/S)",24)
         else
            call gtext("      CONTOUR VALUES",20)
         endif
         it = 0
         if((ispec/2.eq.1 .or. ispec/2.eq.4)
     &      .and. smax.gt.2.) it = 1
         y  = y0 - 0.7*dy
         call gclr(0.0)
         call gmark(x       ,y         ,wd,'L')
         call gclr(0.2)
         call gmark(x       ,y - 1.0*dy,wd,'2')
         call gclr(0.4)
         call gmark(x       ,y - 2.0*dy,wd,'4')
         call gclr(0.6)
         call gmark(x + 0.42,y         ,wd,'6')
         call gclr(0.8)
         call gmark(x + 0.42,y - 1.0*dy,wd,'8')
         call gclr(1.0)
         call gmark(x + 0.42,y - 2.0*dy,wd,'H')
         call grgb(1.,1.,1.)
 
         y  = y0
         ds = 0.2*(smax - smin)
         s  = smin - ds
         do 30 i=1,3
         s  = s + ds
         y  = y - dy
         call gmova2(x,y)
         call gtext("  - ",4)
         if(it.eq.1) write(str6,'(i6)') int(s)
         if(it.ne.1) write(str9,'(1pe9.2)') s
         if(it.eq.1) call gtext(str6,6)
         if(it.eq.1) call gtext(' K',2)
         if(it.ne.1) call gtext(str9,9)
 30      continue
         y  = y0
         x  = 0.67
         do 40 i=1,3
         s  = s + ds
         y  = y - dy
         call gmova2(x,y)
         call gtext("  - ",4)
         if(it.eq.1) write(str6,'(i6)') int(s)
         if(it.ne.1) write(str9,'(1pe9.2)') s
         if(it.eq.1) call gtext(str6,6)
         if(it.eq.1) call gtext(' K',2)
         if(it.ne.1) call gtext(str9,9)
 40      continue
      endif
 
      if(iclr.eq.1) then
         call glogo(0.10,-0.82,0.70)
      else
         call glogo(0.48,-0.82,0.70)
      endif
 
      call gmova2(-1.03,-0.85)
      call glina2(-1.03, 0.53)
      call glina2( 1.03, 0.53)
      call glina2( 1.03,-0.85)
      call glina2(-1.03,-0.85)
 
      call gwidth(0.)
      call gpage
 
      end
*dk eframe0
      subroutine eframe0(titl,time,rshl,ir,smin,smax,vscale)
 
c     This routine draws a border around an equal area plot and writes
c     appropriate labels and captions on the plot.
 
      dimension rshl(*)
      character*8 titl(4,4)
      character str6*6, str9*9, str10*10
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      y0 = -0.560
      dy =  0.042
      wd =  0.025
      pi =  3.141592653589793
 
      call gtwdth(wd)
 
      if(iclr.eq.1 .and. ispec.gt.1)
     &   call legend(0.69,-0.80,0.40,smin,smax)
 
      call gwidth(0.25)
 
      call eborder
 
      x = -0.98
      y = -0.70
      call gmova2(x,y)
      call gtext("TIME   =",8)
      time1 = time
      if(time .lt. 10.) time1 = time*365.25
      write(str10,'(1pe10.3)') time1
      call gtext(str10,10)
      if(iscl.ne.1 .and. time.ge.10.) call gtext(" YR",3)
      if(iscl.ne.1 .and. time.lt.10.) call gtext(" DAYS",5)
 
      if(iclr.ne.1 .and. ispec.ne.1) then
         x  = 0.25
         y  = y0
         call gmova2(x,y)
         if(ispec/2.eq.1 .or. ispec/2.eq.4) then
            call gtext(" TEMPERATURE CONTOUR VALUES",27)
         elseif(ispec/2.eq.8) then
            call gtext("   RADIAL VELOCITY (M/S)",24)
         else
            call gtext("      CONTOUR VALUES",20)
         endif
         it = 0
         if((ispec/2.eq.1 .or. ispec/2.eq.4)
     &      .and. smax.gt.2.) it = 1
         y  = y0 - 0.7*dy
         call gclr(0.0)
         call gmark(x       ,y         ,wd,'L')
         call gclr(0.2)
         call gmark(x       ,y - 1.0*dy,wd,'2')
         call gclr(0.4)
         call gmark(x       ,y - 2.0*dy,wd,'4')
         call gclr(0.6)
         call gmark(x + 0.42,y         ,wd,'6')
         call gclr(0.8)
         call gmark(x + 0.42,y - 1.0*dy,wd,'8')
         call gclr(1.0)
         call gmark(x + 0.42,y - 2.0*dy,wd,'H')
         call grgb(1.,1.,1.)
 
         y  = y0
         ds = 0.2*(smax - smin)
         s  = smin - ds
         do 30 i=1,3
         s  = s + ds
         y  = y - dy
         call gmova2(x,y)
         call gtext("  - ",4)
         if(it.eq.1) write(str6,'(i6)') int(s)
         if(it.eq.1) write(str9,'(1pe9.2)') s
         if(it.eq.1) call gtext(str6,6)
         if(it.eq.1) call gtext(' K',2)
         if(it.ne.1) call gtext(str9,9)
 30      continue
         y  = y0
         x  = 0.67
         do 40 i=1,3
         s  = s + ds
         y  = y - dy
         call gmova2(x,y)
         call gtext("  - ",4)
         if(it.eq.1) write(str6,'(i6)') int(s)
         if(it.eq.1) write(str9,'(1pe9.2)') s
         if(it.eq.1) call gtext(str6,6)
         if(it.eq.1) call gtext(' K',2)
         if(it.ne.1) call gtext(str9,9)
 40      continue
      endif
 
      call gmova2(-1.03,-0.85)
      call glina2(-1.03, 0.53)
      call glina2( 1.03, 0.53)
      call glina2( 1.03,-0.85)
      call glina2(-1.03,-0.85)
 
      call gwidth(0.)
      call gpage
 
      end
*dk eqarmap
      subroutine eqarmap
 
c     This routine plots outlines of the continents in equal
c     area projection.  File 'mapdat' is required as input
c     and must be opened on unit 10.
 
      real b(4), c(2,500), x(0:500), y(500), z(500)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      pi    = 3.141592653589793
      hfpi  = 0.5*pi
      psi   = 0.
      if(ieqar.eq.2) psi = pi
      x(0)  = 0.
 
      rewind (10)
 
      do 40 k=1,283
 
      read(10,10) npts, b, (c(j,1),j=1,2)
 10   format(i4,14x,6f9.3)
 
      npts = npts/2
      read(10,20) ((c(j,i),j=1,2),i=2,npts)
 20   format(8f9.3)
 
      do 30 i=1,npts
      chi    = -psi
      if(c(2,i) .le. 0.) chi = psi
      hflong = 0.5*(0.0174532*c(2,i) + chi)
      colat  = hfpi - 0.0174532*c(1,i)
      scolat = sin(colat)
      rdenom = 1./sqrt(1. + abs(scolat*cos(hflong)))
      x(i)   = rdenom*scolat*sin(hflong)
      y(i)   = rdenom*0.5*cos(colat)
      z(i)   = sign(1., x(i)*x(i-1))
 30   continue
 
      call drawif(x(1),y,z,npts)
 
 40   continue
 
      end
*dk equator
      subroutine equator(p1,p2,e)
 
c     This routine draws the equator on a sphere of unit radius
c     centered at the origin but oriented according to (p1,p2,e).
 
      real p1(3),p2(3),e(3)
 
      xx = dot(p1,1.,0.,0.)
      yy = dot(p2,1.,0.,0.)
      call gmova2(xx,yy)
 
      do 10 i=1,200
 
      xi = cos(0.031415926535898*i)
      yi = sin(0.031415926535898*i)
      xx = dot(p1,xi,yi,0.)
      yy = dot(p2,xi,yi,0.)
 
      if(dot(e,xi,yi,0.) .gt. 0.) then
         call glina2(xx,yy)
      else
         call gmova2(xx,yy)
      endif
 
 10   continue
 
      end
*dk evctplt
      subroutine evctplt(v,xn,ir,scale,nt)
 
c     This routine generates a plot in equal area projection of the
c     radial and tangential components of vector array v at the
c     nodes in layer ir.
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      real v(0:nt,nt+1,10,3,*), xn(0:nt,nt+1,10,3), vt(3)
 
c     The following limits the resolution to that of the nt = 8 grid.
 
      iskp  = 1
      if(nt.gt.8) iskp = nt/8
      arrow = 0.08
      scale = vmaxir(v,ir)
 
      if(scale .eq. 0.)then
         call gmova2(-0.3,0.5)
         call gtext("FIELD IS NULL",13)
         return
      else
         vnorm = arrow/scale
      endif
 
      smll = 0.1*arrow
      smsq = smll**2
      sn   = 1.
      if(ieqar .eq. 2) sn = -1.
 
      do 20 id=1,10
      do 20 i2=1,nt,iskp
      do 20 i1=iskp,nt,iskp
 
c     Compute the radial and tangential components of v.
 
      vrm = vnorm*(v(i1,i2,id,1,ir)*xn(i1,i2,id,1)
     &           + v(i1,i2,id,2,ir)*xn(i1,i2,id,2)
     &           + v(i1,i2,id,3,ir)*xn(i1,i2,id,3))
      do 10 j=1,3
      vt(j) = vnorm*v(i1,i2,id,j,ir) - vrm*xn(i1,i2,id,j)
 10   continue
 
c     Generate arrows proportional to the tangential components.
 
      hflong = 0.5*atan2(sn*xn(i1,i2,id,2) + 0.00001, sn*xn(i1,i2,id,1))
      scolat = sqrt(1. - xn(i1,i2,id,3)**2)
      rdenom = 1./sqrt(1. + abs(scolat*cos(hflong)))
      xx     = rdenom*scolat*sin(hflong)
      yy     = rdenom*0.5*xn(i1,i2,id,3)
      dnrm   = sqrt(xn(i1,i2,id,1)**2 + xn(i1,i2,id,2)**2)
      if(dnrm .gt. 1.e-10) dnrm = 1./dnrm
      dlt    = dnrm*(xn(i1,i2,id,1)*vt(2) - xn(i1,i2,id,2)*vt(1))
      dpl    = max(0., ((vt(1)**2 + vt(2)**2) + vt(3)**2) - dlt**2)
      dpl    = sign(sqrt(dpl),vt(3))
      aa     = sign(1., xn(i1,i2,id,3))
      scolat = sqrt(1. - (xn(i1,i2,id,3) - 0.001*aa)**2)
      rdenom = 1./sqrt(1. + abs(scolat*cos(hflong)))
      dxx    = xx - rdenom*scolat*sin(hflong)
      dyy    = yy - rdenom*0.5*(xn(i1,i2,id,3) - 0.001*aa)
      dnrm   = aa/sqrt(dxx**2 + dyy**2)
      dxt    = dnrm*(dxx*dpl + dyy*dlt)
      dyt    = dnrm*(dyy*dpl - dxx*dlt)
 
      if(dxt**2+dyt**2.gt.smsq) call gvect(xx,yy,xx+dxt,yy+dyt)
 
c     Generate symbols proportional in size to the radial component.
 
      if(abs(vrm).gt.smll) then
         if(vrm.gt.0.) then
            call gtri(xx,yy,0.5*vrm)
         else
            call gsqr(xx,yy,0.5*vrm)
         endif
      endif
 
 20   continue
 
      call grgb(1.,1.,1.)
 
      end
*dk gclr
      subroutine gclr(x)
 
c     This routine sets the CGS color to one of 41 colors from pure
c     blue to pure red as x varies from zero to one.
 
      common /color/ red(41), grn(41), blu(41)
 
      i = 1 + 40.*x
 
      call grgb(red(i),grn(i),blu(i))
 
      end
*dk ghxgn
      subroutine ghxgn(p1,p2,e,xn,i1,i2,id,nt)
 
c     This routine plots a hexagon (pentagon for pentagonal points)
c     about node (i1,i2,id) so as to bisect the cell edges.
 
      real p1(3), p2(3), e(3), xn(0:nt,nt+1,10,3), x(3,6)
      common /hxgn/ j1e(6), j2e(6)
 
      if(dotpr(e,xn,i1,i2,id,nt).lt.0.) return
 
      thd = 1./3.
      nbr = 6
      if((i1.eq.0.and.i2.eq.1) .or. (i1.eq.nt.and.i2.eq.1)) nbr = 5
 
      do 30 i=1,nbr
      if(i1.eq.0.and.i2.eq.1) then
         ip = 5*((id-1)/5)
         do 10 j=1,3
         x(j,i) = thd*(xn(1,1,ip+i,j) + xn(2,1,ip+i,j)
     &               + xn(1,2,ip+i,j))
 10      continue
      else
         j1 = i1 + j1e(i)
         j2 = i2 + j2e(i)
         k1 = j1 + mod(i+1,2) - 1
         k2 = j2 + mod(i+1,2)
         do 20 j=1,3
         x(j,i) = thd*(xn(j1,j2,id,j) + xn(j1-1,j2+1,id,j)
     &               + xn(k1,k2,id,j))
 20      continue
      endif
 30   continue
 
      call gmova2(dprd(x(1,1),p1),dprd(x(1,1),p2))
      do 40 i=2,nbr
      call glina2(dprd(x(1,i),p1),dprd(x(1,i),p2))
 40   continue
      call glina2(dprd(x(1,1),p1),dprd(x(1,1),p2))
 
      end
*dk glogo
      subroutine glogo(x0,y0,width)
 
c     This routine writes "los alamos", in hollow letters, on the
c     line from (x0,y0) to (x0+width,y0) in window coordinates.
 
      dimension x(300), y(300), lmode(300)
 
      if(width .gt. 0.) return
 
      open (88, file='insignia', status='unknown')
 
      del = 0.05*width
 
      do 30 k=1,9
 
      read(88,*) npts
      read(88,*) (x(i),y(i),lmode(i),i=1,npts)
 
      do 10 i=1,npts
      x(i) = x0 + del*x(i)
      y(i) = y0 + del*y(i) - 0.2*width
 10   continue
 
      call gmova2(x(1),y(1))
 
      do 20 i=2,npts
      if(lmode(i-1).eq.2)then
         call gmova2(x(i),y(i))
      else
         call glina2(x(i),y(i))
      endif
 20   continue
 
 30   continue
 
      call close(88)
 
      end
*dk gmark
      subroutine gmark(x,y,wd,symbol)
 
c     This routine plots the character 'symbol' centered at
c     (x,y) assuming a character width wd.
 
      character*1 symbol
 
      call gmova2(x-0.5*wd, y-0.5*wd)
 
      call gtext(symbol,1)
 
      end
*dk gplotnew
      subroutine gplotnew(casenum)
 
      common /plbuff/ ibuff(1024)
      common /plvscb/ ivscb(300)
      character casenum*3, pltname*8
 
      call gstart
      call gplbeg(ivscb,ibuff,1024)
      call gclass(ivscb,'u')
      call gtitle(ivscb,'terra',5)
      pltname = 'plt'//casenum//'  '
      call gfname(ivscb,pltname)
      call gplend(ivscb)
 
      end
*dk gridplt
      subroutine gridplot(p1,p2,e,nplt)
 
c     This routine generates a plot of the icosahedral grid.
 
      real xn(0:64,65,10,3), xg(65**2*3)
      real p1(3), p2(3), e(3), s1(65), s2(65), s3(65)
 
      n   = 64
      m   = max(1,n/nplt)
      j1  = m + 1
 
      call grdgen(xn,xg,n)
 
      do 120 id=1,10
 
         do 20 i2=1,n,m
            do 10 i1=1,n+1
            s1(i1) = dotpr(p1,xn,i1-1,i2,id,n)
            s2(i1) = dotpr(p2,xn,i1-1,i2,id,n)
            s3(i1) = dotpr( e,xn,i1-1,i2,id,n)
 10         continue
         call drawif(s1,s2,s3,n+1)
 20      continue
 
         do 40 i1=m,n,m
            do 30 i2=1,n+1
            s1(i2) = dotpr(p1,xn,i1,i2,id,n)
            s2(i2) = dotpr(p2,xn,i1,i2,id,n)
            s3(i2) = dotpr( e,xn,i1,i2,id,n)
 30         continue
         call drawif(s1,s2,s3,n+1)
 40      continue
 
         do 60 j=j1,n+1,m
            do 50 i=1,j
            ji1 = j - i
            s1(i) = dotpr(p1,xn,ji1,i,id,n)
            s2(i) = dotpr(p2,xn,ji1,i,id,n)
            s3(i) = dotpr( e,xn,ji1,i,id,n)
 50         continue
         call drawif(s1,s2,s3,j)
 60      continue
 
         if(j1.ge.n) go to 90
 
         do 80 j=j1,n,m
            nj1 = n - j + 2
            do 70 i=1,nj1
            ni1 = n - i + 1
            ji1 = j + i - 1
            s1(i) = dotpr(p1,xn,ni1,ji1,id,n)
            s2(i) = dotpr(p2,xn,ni1,ji1,id,n)
            s3(i) = dotpr( e,xn,ni1,ji1,id,n)
 70         continue
         call drawif(s1,s2,s3,nj1)
 80      continue
 90      continue
 
c        call gwidth(0.25)
c        do 100 i1=1,n+1
c           s1(i1) = dotpr(p1,xn,i1-1,1,id,n)
c           s2(i1) = dotpr(p2,xn,i1-1,1,id,n)
c           s3(i1) = dotpr( e,xn,i1-1,1,id,n)
c100     continue
c        call drawif(s1,s2,s3,n+1)
c        do 110 i2=1,n+1
c           s1(i2) = dotpr(p1,xn,n,i2,id,n)
c           s2(i2) = dotpr(p2,xn,n,i2,id,n)
c           s3(i2) = dotpr( e,xn,n,i2,id,n)
c110     continue
c        call drawif(s1,s2,s3,n+1)
c        call gwidth(0.0)
 120  continue
 
c     Draw circle of unit radius.
 
      call circle(0.,0.,1.)
 
      end
*dk gsclr
      subroutine gsclr(x,p1,p2,e,xn,i1,i2,ie,id,nt)
 
c     This routine plots a triangle, properly foreshortened for
c     the view angle, with magnitude x (x may vary between 0.0
c     and 1.0) centered at the center of the element with indices
c     (i1,i2,ie,id).
 
      real p1(3), p2(3),  e(3), xn(0:nt,nt+1,10,3)
      real x1(3), x2(3), x3(3)
 
      if(x .lt. 0.10) return
      if(dotpr(e,xn,i1,i2,id,nt) .lt. 0.) return
 
      aa = 0.9*x
      j1 = i1 + ie - 2
      j2 = i2 + ie - 1
      do 10 j=1,3
      xc = (xn(i1,i2,id,j) + xn(i1-1,i2+1,id,j) + xn(j1,j2,id,j))/3.
      x1(j) = xc + aa*(xn(i1,i2,id,j)-xc)
      x2(j) = xc + aa*(xn(i1-1,i2+1,id,j)-xc)
      x3(j) = xc + aa*(xn(j1,j2,id,j)-xc)
 10   continue
 
      call gmova2(dprd(x1,p1),dprd(x1,p2))
      call glina2(dprd(x2,p1),dprd(x2,p2))
      call glina2(dprd(x3,p1),dprd(x3,p2))
      call glina2(dprd(x1,p1),dprd(x1,p2))
 
      end
*dk gsqr
      subroutine gsqr(x,y,size)
 
c     This routine draws a square with side dimension size
c     centered at (x,y).
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      dx    = 0.50*size
 
      call gmova2(x - dx,y - dx)
      call glina2(x + dx,y - dx)
      call glina2(x + dx,y + dx)
      call glina2(x - dx,y + dx)
      call glina2(x - dx,y - dx)
 
      end
*dk gtri
      subroutine gtri(x,y,size)
 
c     This routine draws a triangle of height size centered
c     at (x,y).
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      dx    = 0.57735*size
      dy    = 0.33333*size
 
      call gmova2(x - dx,y - dy)
      call glina2(x + dx,y - dy)
      call glina2(x,y + dy + dy)
      call glina2(x - dx,y - dy)
 
      end
*dk gvect
      subroutine gvect(x1,y1,x2,y2)
 
c     This routine draws an arrow from point (x1,y1) to point (x2,y2).
c     The head of the arrow is proportional in size to its length.
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      dx    = x2 - x1
      dy    = y2 - y1
 
      call gmova2(x1,y1)
      call glina2(x2,y2)
      call glina2(x2 + dy/7.0,y2 - dx/7.0)
      call glina2(x2 + dx/3.0,y2 + dy/3.0)
      call glina2(x2 - dy/7.0,y2 + dx/7.0)
      call glina2(x2,y2)
 
      end
*dk kontour
      subroutine kontour(s,xv,con,id,ir,ncon,itype,nt)
 
      real s(0:nt,nt+1,10,*), xv(0:nt,nt+1,2), con(*)
      real x1(2), y1(2)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /kntr1/ j1(4,2), j2(4,2)
      common /kntr2/ wid(3), ccon(3)
      common /kntr3/ cntrclr(3)
      character marker*1
 
      wd = 0.017
      if(itype.eq.1) wd = 0.035
 
      call gtwdth(wd)
 
      hfpi = asin(1.)
 
      if(itype.eq.1) then
         xmax = 2.
         ymax = 2.
      else
         xmax = hfpi
         ymax = 0.5*log(tan(0.5*hfpi + 0.625))
      endif
 
      isplt = 0
      if(itype.eq.2 .and. ieqar.eq.1 .and. id.eq.4) isplt = 2
      if(itype.eq.2 .and. ieqar.eq.2 .and. id.eq.6) isplt = 2
      if(itype.eq.3) isplt = 1
      if(itype.eq.4) isplt = 2
 
      dclr = 1./(ncon - 1)
      inc  = max(1, (ncon - 1)/10)
 
      do 50  k=1,ncon
 
      if(ncon.eq.2) then
         con(k) = 0.
         call grgb(1.,0.,1.)
         call gwidth(1.)
      elseif(ncon.eq.3) then
         con(k) = ccon(k)
         call gclr(cntrclr(k))
         if(k .eq. 1) call grgb(1.,1.,1.)
         call gwidth(wid(k))
      else
         call gclr((k - 1)*dclr)
         if(k.eq.1+inc*0)  marker = 'L'
         if(k.eq.1+inc*1)  marker = '1'
         if(k.eq.1+inc*2)  marker = '2'
         if(k.eq.1+inc*3)  marker = '3'
         if(k.eq.1+inc*4)  marker = '4'
         if(k.eq.1+inc*5)  marker = '5'
         if(k.eq.1+inc*6)  marker = '6'
         if(k.eq.1+inc*7)  marker = '7'
         if(k.eq.1+inc*8)  marker = '8'
         if(k.eq.1+inc*9)  marker = '9'
         if(k.eq.1+inc*10) marker = 'H'
      endif
 
      mark = 0
 
      do 40 i1=1,nt
      do 40 i2=1,nt
      do 40 ie=1,2
      if(itype.eq.3 .and. i2.ge.i1) go to 40
      if(itype.eq.4 .and. i2.le.i1) go to 40
      k1 = 0
      k2 = 0
      k3 = 0
      if(con(k).gt.s(i1+j1(1,ie),i2+j2(1,ie),id,ir)) k1 = 1
      if(con(k).gt.s(i1+j1(2,ie),i2+j2(2,ie),id,ir)) k2 = 1
      if(con(k).gt.s(i1+j1(3,ie),i2+j2(3,ie),id,ir)) k3 = 1
 
c     If product .ne. 0, then all three are equal to one. If sum .eq. 0,
c     then all three are equal to zero.  For either case, the contour
c     does not pass through the triangle, so skip to 40 and try the next
c     triangle . . .
 
      if(k1.ne.0 .and. k2.ne.0 .and. k3.ne.0) go to 40
      if(k1+k2+k3 .eq. 0) go to 40
 
      l = 0
      if(k1+k2.ne.1) go to 10
      m = 1
      go to 30
   10 if(k2+k3.ne.1) go to 20
      m = 2
      go to 30
   20 if(k3+k1.ne.1) go to 40
      m = 3
 
   30 l     = l + 1
      m1    = m + 1
      sa    =  s(i1+j1(m ,ie),i2+j2(m ,ie),id,ir)
      sb    =  s(i1+j1(m1,ie),i2+j2(m1,ie),id,ir)
      xx    = (con(k) - sa)/(sb - sa + 1.e-40)
      xa    = xv(i1+j1(m ,ie),i2+j2(m ,ie),1)
      xb    = xv(i1+j1(m1,ie),i2+j2(m1,ie),1)
      if(isplt.eq.1 .and. xa.lt.0.) xa = -xa
      if(isplt.eq.1 .and. xb.lt.0.) xb = -xb
      if(isplt.eq.2 .and. xa.gt.0.) xa = -xa
      if(isplt.eq.2 .and. xb.gt.0.) xb = -xb
      x1(l) = xa + (xb - xa)*xx
      ya    = xv(i1+j1(m ,ie),i2+j2(m ,ie),2)
      yb    = xv(i1+j1(m1,ie),i2+j2(m1,ie),2)
      y1(l) = ya + (yb - ya)*xx
 
      if(l.lt.2) go to (10,20,40),m
 
      if(abs(x1(1)).lt.xmax.and.abs(x1(2)).lt.xmax.and.
     &   abs(y1(1)).lt.ymax.and.abs(y1(2)).lt.ymax) then
         if(ncon .gt. 3) mark = mark + 1
         if((mod(k,inc).eq.1 .or. inc.eq.1) .and. mod(mark,nt*3).eq.1)
     &      call gmark(x1(1),y1(1),wd,marker)
         call gmova2(x1(1),y1(1))
         call glina2(x1(2),y1(2))
      endif
 
      l = 0
      go to (10,20,40),m
 
   40 continue
 
   50 continue
 
      call gwidth(0.)
 
      end
*dk latlong
      subroutine latlong(nlat,nlong,p1,p2,e)
 
c     This routine draws circles of constant latitude and longitude
c     on the unit sphere.
 
      real p1(3), p2(3), e(3), s1(101), s2(101), s3(101)
 
      pi     = 3.141592653589793
 
c     Draw meridians.
 
      dphi   = 0.02*pi
      dtheta = 2.*pi/nlong
      do 20 j=1,nlong
      theta  = (j-1)*dtheta
      cost   = cos(theta)
      sint   = sin(theta)
      do 10 i=1,51
      phi    = (i-1)*dphi
      z      = cos(phi)
      r      = sin(phi)
      x      = r*cost
      y      = r*sint
      s1(i)  = p1(1)*x + p1(2)*y + p1(3)*z
      s2(i)  = p2(1)*x + p2(2)*y + p2(3)*z
      s3(i)  =  e(1)*x +  e(2)*y +  e(3)*z
 10   continue
      call drawif(s1,s2,s3,51)
 20   continue
 
c     Draw parallels.
 
      dtheta = 0.02*pi
      dphi   = pi/nlat
      do 40 j=1,nlat-1
      phi    = j*dphi
      z      = cos(phi)
      r      = sin(phi)
      do 30 i=1,101
      theta  = (i-1)*dtheta
      x      = r*cos(theta)
      y      = r*sin(theta)
      s1(i)  = p1(1)*x + p1(2)*y + p1(3)*z
      s2(i)  = p2(1)*x + p2(2)*y + p2(3)*z
      s3(i)  =  e(1)*x +  e(2)*y +  e(3)*z
 30   continue
      call drawif(s1,s2,s3,101)
 40   continue
 
      end
*dk legend
      subroutine legend(xorig,yorig,height,smin,smax)
 
c     This routine draws a legend to identify scalar field
c     magnitudes with the colors used in routine clrplt.
 
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      character str5*5, str9*9
 
      call gwidth(0.25)
      h  = 0.0015
      nl = int(0.2*height/h + 0.5)
      x1 = xorig
      x2 = xorig + 0.13*height
      y  = yorig - 0.5*h
      a  = 0.2/nl
 
      do 10 i=1,5*nl
      y = y + h
      c = a*(i-1)
c     c = 1. - c
      call gclr(c)
      call gmova2(x1,y)
      call glina2(x2,y)
 10   continue
 
      call grgb(1.,1.,1.)
      ds = 0.2*(smax-smin)
      x1 = xorig + 0.15*height
 
      y = yorig - 0.010
      do 20 i=0,5
      call gmova2(x1,y)
      s = smin + i*ds
      y = y + nl*h
      if(iscl.eq.1.or.ispec.eq.6.or.ispec.eq.7) then
         write(str5,'(f5.2)') s
         call gtext(str5,5)
      else
         write(str9,'(1pe9.2)') s
         call gtext(str9,9)
      endif
 20   continue
 
      if(xorig.lt.0.) then
         x = xorig
         y = yorig - 0.12
         call gmova2(x,y)
         if(ispec/2.eq.1 .or. ispec/2.eq.4) then
            call gtext("TEMPERATURE ",12)
            if(iscl.ne.1) call gtext("K",1)
         elseif(ispec/2.eq.2) then
            call gtext("PRESSURE",8)
         elseif(ispec/2.eq.3) then
            call gtext("LOG VISCOSITY",13)
         elseif(ispec/2.eq.5) then
            call gtext("GRAVITY ANOMALY",15)
         elseif(ispec/2.eq.6) then
            call gtext("EQUIPOTENTIAL",13)
         elseif(ispec/2.eq.7) then
            call gtext("TOPOGRAPHY",10)
         elseif(ispec/2.eq.8) then
            call gtext("RADIAL VELOCITY",15)
         elseif(ispec/2.eq.9) then
            call gtext("SHEAR HEATING",13)
         endif
      else
         x =  0.27
         y = -0.602
         call gmova2(x,y)
         if(ispec/2.eq.1 .or. ispec/2.eq.4) then
            call gtext("    TEMPERATURE",15)
            call gmova2(x,y-0.042)
            if(iscl.ne.1) call gtext("     (KELVINS) ",15)
         elseif(ispec/2.eq.2) then
            call gtext("      AMPLITUDE",15)
         elseif(ispec/2.eq.3) then
            call gtext("  LOG VISCOSITY",15)
         elseif(ispec/2.eq.5) then
            call gtext("GRAVITY ANOMALY",15)
            call gmova2(x,y-0.042)
            call gtext("  (M/SEC**2)   ",15)
         elseif(ispec/2.eq.6) then
            call gtext(" EQUIPOTENTIAL ",15)
            call gmova2(x,y-0.042)
            call gtext(" DEFLECTION (M)",15)
         elseif(ispec/2.eq.7) then
            call gtext("  TOPOGRAPHIC  ",15)
            call gmova2(x,y-0.042)
            call gtext("   HEIGHT (M)  ",15)
         elseif(ispec/2.eq.8) then
            call gtext("RADIAL VELOCITY",15)
            call gmova2(x,y-0.042)
            call gtext("    (M/SEC)    ",15)
         elseif(ispec/2.eq.9) then
            call gtext(" SHEAR HEATING ",15)
            call gmova2(x,y-0.042)
            call gtext("   (W/M**3)    ",15)
         endif
      endif
 
      call gwidth(0.)
 
      end
*dk mapplot
      subroutine mapplot(p1,p2,e)
 
c     This routine plots outlines of the continents on the sphere.
c     File 'mapdat' is required as input and must be opened on unit 10.
 
      real p1(3), p2(3), e(3), b(4), c(2,100), x(100), y(100), z(100)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      rewind (10)
 
      do 40 k=1,283
 
      read(10,10) npts, b, (c(j,1),j=1,2)
 10   format(i4,14x,6f9.3)
 
      npts = npts/2
      read(10,20) ((c(j,i),j=1,2),i=2,npts)
 20   format(8f9.3)
 
      do 30 i=1,npts
      xx   = cos(0.0174533*c(1,i))*cos(0.0174533*c(2,i))
      yy   = cos(0.0174533*c(1,i))*sin(0.0174533*c(2,i))
      zz   = sin(0.0174533*c(1,i))
      x(i) = p1(1)*xx + p1(2)*yy + p1(3)*zz
      y(i) = p2(1)*xx + p2(2)*yy + p2(3)*zz
      z(i) =  e(1)*xx +  e(2)*yy +  e(3)*zz
 30   continue
 
      call drawif(x,y,z,npts)
 
 40   continue
 
      end
*dk movie
      subroutine movie(v,s,pmap,titl,w)
 
c     This routine generates film output according to the
c     specifications of common block /splt/.
 
      include 'size.h'
      common /mesh/ xn((nt+1)**2,10,3)
      common /radl/ rshl(nr+1), ird, ibc
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /fnam/ vname, sname, cname
      character*8 vname, sname, cname
      common /clck/ itmng, sec(50), nop(50)
      call second(tin)
 
      if(ispec .eq. 0) return
 
      vname = '        '
      sname = '        '
      cname = '        '
      if(mod(ispec,2).eq.1)          vname = ' terra  '
      if(ispec.ne.1)                 sname = ' terra  '
      if(ispec.eq.8 .or. ispec.eq.9) cname = ' terra  '
 
      call sphplot(v,s,pmap,titl,rshl,xn,w)
 
      call second(tout)
      sec(30) = sec(30) + tout - tin
      end
*dk pdraw
      subroutine pdraw(rshl,xn,titl)
 
c     This routine plots the particles as points on the sphere in an
c     equal area projection.
 
      include 'size.h'
      parameter (np=(nt+1)**2*nd*5)
      real rshl(*), xn(0:mt,mt+1,10,3)
      character*8 titl(4,4)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /prt1/ npart, p(np), q(np), idp(np), kpl(np), ap(np)
      logical tri
 
      call gscrn2(-1.08,1.08,-0.88,0.56)
      call gwind2(-1.10,1.10,-0.88,0.56)
      call gtwdth(0.050)
      call gtfnta
 
c     sn   = 1.
c     if(ieqar .eq. 2) sn = -1.
      sn = 1.
 
      call grgb(0.,1.,0.)
 
      do 10 ip=1,npart
 
      a   = mod(p(ip), 1.)
      b   = mod(q(ip), 1.)
      tri = a + b .le. 1.
      id  = idp(ip)
      i1  = int(p(ip))
      i2  = int(q(ip)) + 1
      if(tri) then
         j1 = i1 - 1
         j2 = i2
         alpha = a
         beta  = b
      else
         j1 = i1
         j2 = i2 + 1
         alpha = 1. - b
         beta  = 1. - a
      endif
      gamma = 1. - alpha - beta
      x1  = alpha*xn(i1,i2,id,1) + beta*xn(i1-1,i2+1,id,1)
     &    + gamma*xn(j1,j2,id,1)
      x2  = alpha*xn(i1,i2,id,2) + beta*xn(i1-1,i2+1,id,2)
     &    + gamma*xn(j1,j2,id,2)
      x3  = alpha*xn(i1,i2,id,3) + beta*xn(i1-1,i2+1,id,3)
     &    + gamma*xn(j1,j2,id,3)
      xq  = 1./sqrt(x1**2 + x2**2 + x3**2)
 
      hflong = 0.5*atan2(sn*xq*x2 + 0.00001, sn*xq*x1)
      scolat = sqrt(1. - (xq*x3)**2)
      rdenom = 1./sqrt(1. + abs(scolat*cos(hflong)))
      xx     = rdenom*scolat*sin(hflong)
      yy     = rdenom*0.5*xq*x3
 
      call gmark(xx, yy, 0.05, '+')
 
 10   continue
 
      call grgb(1.,1.,1.)
 
      call eframe(titl,0.,rshl,1,0.,0.,0.)
 
      end
*dk pframe
      subroutine pframe(titl,time,rshl,ir,iang,vscale)
 
c     This routine writes title information, labels, and captions on
c     orthographic projection plots.
 
      dimension rshl(*)
      character*8 titl(4,4)
      character str3*3, str10*10
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      call gwidth(0.25)
      call gmova2(-2.00,1.00)
      call gtext(titl(1,1),32)
      call gmova2(-2.00,0.90)
      call gtext(titl(1,2),32)
      call gmova2(-2.00,0.80)
      call gtext(titl(1,3),32)
      call gmova2(-2.00,0.70)
      call gtext(titl(1,4),32)
 
      if(time.ne.0.) then
         call gmova2(-2.00,-0.75)
         call gtext("TIME   =",8)
         time1 = time
         if(time .lt. 10.) time1 = time*365.25
         write(str10,'(1pe10.3)') time1
         call gtext(str10,10)
         if(iscl.ne.1 .and. time.ge.10.) call gtext(" YR",3)
         if(iscl.ne.1 .and. time.lt.10.) call gtext(" DAYS",5)
      endif
 
      if(ir.gt.0) then
         call gmova2(-2.00,-0.85)
         call gtext("DEPTH  =",8)
         dep = rshl(1) - rshl(ir)
         if(iscl.ne.1) dep = 0.001*dep
         write(str10,'(1pe10.3)') dep
         call gtext(str10,10)
         if(iscl.ne.1) call gtext(" KM",3)
 
         call gmova2(-2.00,-0.95)
         call gtext("VIEW FROM ",10)
         if(iang.ge.0) then
            write(str3,'(i3)') iang
            call gtext(str3,3)
            call gtext(" DEGREES LONGITUDE",18)
         elseif(iang.eq.-1) then
            call gtext("THE NORTH POLE",14)
         elseif(iang.eq.-2) then
            call gtext("THE SOUTH POLE",14)
         endif
      elseif(ir.eq.0) then
         call gmova2(-0.02,-1.09)
         call gtext("0",1)
         call gmova2( 1.04,-0.02)
         call gtext("90",2)
         call gmova2(-0.07, 1.05)
         call gtext("180",3)
         call gmova2(-1.17,-0.02)
         call gtext("270",3)
         call gmova2(-2.00,-0.85)
         call gtext("EQUATORIAL SECTION",18)
         call gmova2(-2.00,-0.95)
         call gtext("ZERO LONGITUDE AT BOTTOM",24)
      else
         write(str3,'(i3)') iang
         call gmova2(-2.00,-0.85)
         call gtext("MERIDIANAL SECTION",18)
         call gmova2(-2.00,-0.95)
         call gtext("ALONG ",6)
         call gtext(str3,3)
         call gtext(" DEGREES LONGITUDE",18)
         call gmova2(-1.17,-0.02)
         call gtext(str3,3)
         call gmova2( 1.04,-0.02)
         long = iang + 180
         write(str3,'(i3)') long
         call gtext(str3,3)
         call gmova2(-0.07, 1.05)
         call gtext(" NP",3)
         call gmova2(-0.07,-1.09)
         call gtext(" SP",3)
      endif
 
      if(vscale.ne.0.) then
         call gmova2(-2.00,-1.05)
         if(vscale.lt.1.e-5.or.iscl.eq.1) then
            call gtext("MAXIMUM VELOCITY =",18)
            vscl = 3.1558e9*vscale
            if(iscl .eq. 1) vscl = vscale
            write(str10,'(1pe10.3)') vscl
            call gtext(str10,10)
            if(iscl.ne.1) call gtext(" CM/YR",6)
         else
            call gtext("MAXIMUM VELOCITY =",18)
            write(str10,'(1pe10.3)') vscale
            call gtext(str10,10)
            if(iscl.ne.1) call gtext(" M/SEC",6)
         endif
      endif
 
      call glogo(0.55,-1.08,1.0)
      call gmova2(-2.10,-1.15)
      call glina2(-2.10, 1.15)
      call glina2( 1.35, 1.15)
      call glina2( 1.35,-1.15)
      call glina2(-2.10,-1.15)
 
      call gwidth(0.)
      call gpage
 
      end
*dk pframe0
      subroutine pframe0(titl,time,rshl,ir,iang,vscale)
 
c     This routine writes title information, labels, and captions on
c     orthographic projection plots.
 
      dimension rshl(*)
      character*8 titl(4,4)
      character str10*10
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      call gwidth(0.25)
      call gmova2(-2.00,-0.95)
      call gtext("TIME   =",8)
      time1 = time
      if(time .lt. 10.) time1 = time*365.25
      write(str10,'(1pe10.3)') time1
      call gtext(str10,10)
      if(iscl.ne.1 .and. time.ge.10.) call gtext(" YR",3)
      if(iscl.ne.1 .and. time.lt.10.) call gtext(" DAYS",5)
 
      call gmova2(-2.10,-1.15)
      call glina2(-2.10, 1.15)
      call glina2( 1.35, 1.15)
      call glina2( 1.35,-1.15)
      call glina2(-2.10,-1.15)
 
      call gwidth(0.)
      call gpage
 
      end
*dk pltradl
      subroutine pltradl
 
c     This routine generates plots versus depth of spherically-averaged
c     density and temperature as well as coefficient of thermal
c     expansion, specific heat at constant volume, Gruneisen gamma,
c     thermal conductivity, bulk modulus, and viscosity.
 
      include 'size.h'
      include 'pcom.h'
      common /radl/ rshl(nr+1), ird, ibc
      common /name/ titl(4,4)
      common /prop/ ieos,  rho0, visc,  grav,  texpn, tcond,
     &              sheat, hgen, tb(2), cl410, cl660
      common /cycl/ iter, time, tstep, step
      common /heat/ htop, hbot, hrad, heat, hshr, hvol, hnet, tnrm,
     &              tav(129), qc(128)
      common /eos1/ rhorf(129), tmprf(129), drhdp(129), grv(129)
      common /eos2/ rhocv(129), gamma(129), alpha(129), prf(129),
     &               cond(129)
      common /vis2/ rdvsc(129), tactv(129), vscl(129)
      common /shrh/ shrlayr(129)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      real de(129), tm(129), pr(129), vs(129), al(129), sh(129)
      real bm(129), cn(129), gm(129), gv(129), qr(129), hs(129), zz(129)
      common /urut/ ur(129), ut(129)
      common /plrd1/ td(0:1), tt(0:1), tp(0:1), tv(0:1), te(0:1),
     &               ts(0:1), tk(0:1), tc(0:1), tu(0:1), tr(0:1),
     &               tq(0:1), th(0:1), tg(0:1), ta(0:1), tz(0:1)
      character*32 td, tt, tp, tv, te, ts, tk, tc, tu, tr, tq, th,
     &             tg, ta, tz
      common /plrd2/ premdep(20), premden(20)
      character titl*8, str10*10, ctitl*30
 
      call uradtng
 
      if(mynum .ne. 0) return
 
      norm  = 0
      eta   = rshl(nr+1)/rshl(1)
      rfac  = 1. - 3.*eta**2 + 2.*eta**3
      dthg  = hgen*rshl(1)**2/(6.*tcond)*rfac
      delt  = tb(2) - tb(1)
      if(tb(2).eq.0.) delt = dthg
 
      if(norm.eq.1) then
         rscl = 1./rshl(1)
         uscl = (rshl(1) - rshl(nr+1))*rho0*sheat/tcond
      else
         rscl = 0.001
         uscl = 3.1558e9
      endif
 
      do 20 ir=1,nr+1
      de(ir) = rhorf(ir)
      if(norm.eq.1) de(ir) = de(ir)/rho0
      tm(ir) = tav(ir)
      if(norm.eq.1) tm(ir) = (tav(ir) - tb(1))/delt
      pr(ir) = prf(ir)
      gv(ir) = grv(ir)
      vs(ir) = log10(visc*rdvsc(ir))
      al(ir) = alpha(ir)
      sh(ir) = rhocv(ir)/rhorf(ir)
      if(abs(sh(ir) - sh(1)) .lt. 0.1) sh(ir) = sh(1)
      bm(ir) = rhorf(ir)/(drhdp(ir) + 1.e-40)
      gm(ir) = gamma(ir)
      cn(ir) = cond(ir)
      ur(ir) = uscl*ur(ir)
      ut(ir) = uscl*ut(ir)
      qr(ir) = hbot
      if(ir .le. nr) qr(ir) = qc(ir)
      hs(ir) = shrlayr(ir)
      zz(ir) = rscl*(rshl(1) - rshl(ir))
 20   continue
 
      write(str10,'(1pe10.3)') time
      ctitl = titl(1,1)//'   time ='// str10//' yr'
 
      call libhi
      call gscrn2(0.0,1.33,0.0,1.05)
      call gview2(0.0,1.33,0.0,1.05)
      call hseqv (0.0,1.33,0.0,1.05)
      call hdasmp('x', 1)
      call hdasmp('y', 1)
      call haxrul('x', 0.0, 0.0, 0.0, 'default')
      call haxrul('y', 0.0, 0.0, 0.0, 'default')
c     call haxgrd('x', 1)
c     call haxgrd('y', 1)
      call gwidth(0.25)
 
      call gwind2(-0.2,1.13,-0.3,0.75)
      call gtwdth(0.020)
      call gmova2(0.10,1.50)
      call htitle(ctitl)
 
      if(ieos/10.ne.0) then
 
         call gwind2(0.0,1.90,-0.60,0.80)
         call hcvcol('green','off')
         call hxy(zz,de,nr+1,tz(norm),td(norm),' ')
         if(ieos/10 .eq. 1) then
            call hcvcol('magenta','off')
            call hcvls('dot','off')
            call hcvmrk('plus',20,'off')
            call hcurve(premdep,premden,20)
            call hcurve(premdep,premden,20)
            call hcvls('solid','off')
            call hcvmrk('nomarker',1,'off')
         endif
 
         call gwind2(0.0,1.90,0.03,1.43)
         call hcvcol('magenta','off')
         call hxy(zz,tm,nr+1,tz(norm),tt(norm),' ')
 
         call gwind2(-0.95,0.95,-0.60,0.80)
         call hcvcol('green','off')
         call hxy(zz,pr,nr+1,tz(norm),tp(norm),' ')
 
         call gwind2(-0.95,0.95,0.03,1.43)
         call hcvcol('cyan','off')
         call hxy(zz,gv,nr+1,tz(norm),ta(norm),' ')
 
         call gpage
         call gwind2(-0.2,1.13,-0.3,0.75)
         call gtwdth(0.020)
         call gmova2(0.10,0.98)
         call htitle(ctitl)
         call gwind2(0.0,1.90,-0.60,0.80)
         call hcvcol('red','off')
         call hxy(zz,al,nr+1,tz(norm),te(norm),' ')
 
         call gwind2(0.0,1.90,0.03,1.43)
         call hcvcol('green','off')
         call hxy(zz,bm,nr+1,tz(norm),tk(norm),' ')
 
         call gwind2(-0.95,0.95,-0.60,0.80)
         call hcvcol('cyan','off')
         call hxy(zz,gm,nr+1,tz(norm),tg(norm),' ')
 
         call gwind2(-0.95,0.95,0.03,1.43)
         call hcvcol('magenta','off')
         call hxy(zz,sh,nr+1,tz(norm),ts(norm),' ')
 
         call gpage
         call gwind2(-0.2,1.13,-0.3,0.75)
         call gtwdth(0.020)
         call gmova2(0.10,0.98)
         call htitle(ctitl)
         call gwind2(0.0,1.90,-0.60,0.80)
         call hcvcol('cyan','off')
         call hxy(zz,vs,nr+1,tz(norm),tv(norm),' ')
 
         call gwind2(-0.95,0.95,-0.60,0.80)
         call hcvcol('magenta','off')
         call hxy(zz,cn,nr+1,tz(norm),tc(norm),' ')
 
         call gpage
         call gwind2(-0.2,1.13,-0.3,0.75)
         call gtwdth(0.020)
         call gwind2(0.0,1.90,0.03,1.43)
         call htitle(ctitl)
         call gwind2(0.0,1.90,-0.60,0.80)
         call hcvcol('green','off')
         call hxy(zz,ut,nr+1,tz(norm),tu(norm),' ')
 
         call gwind2(0.0,1.90,0.03,1.43)
         call hcvcol('green','off')
         call hxy(zz,ur,nr+1,tz(norm),tr(norm),' ')
 
         call gwind2(-0.95,0.95,-0.60,0.80)
         call hcvcol('magenta','off')
         call hxy(zz,qr,nr+1,tz(norm),tq(norm),' ')
 
         call gwind2(-0.95,0.95,0.03,1.43)
         call hcvcol('red','off')
         call hxy(zz,hs,nr+1,tz(norm),th(norm),' ')
 
         call gpage
 
      else
 
         call gwind2(0.0,1.90,-0.60,0.80)
         call hcvcol('red','off')
         call hxy(zz,tm,nr+1,tz(norm),tt(norm),' ')
 
         call gwind2(0.0,1.90,0.03,1.43)
         call hcvcol('magenta','off')
         if(rdvsc(nr/2).eq.rdvsc(1) .and.
     &      rdvsc(nr/2).eq.rdvsc(nr+1)) then
            call hxy(zz,qr,nr+1,tz(norm),tq(norm),' ')
         else
            call hxy(zz,vs,nr+1,tz(norm),tv(norm),' ')
         endif
 
         call gwind2(-0.95,0.95,-0.60,0.80)
         call hcvcol('green','off')
         call hxy(zz,ut,nr+1,tz(norm),tu(norm),' ')
 
         call gwind2(-0.95,0.95,0.03,1.43)
         call hcvcol('green','off')
         call hxy(zz,ur,nr+1,tz(norm),tr(norm),' ')
 
         call gpage
 
      endif
 
      end
*dk quadcntr
      subroutine quadcntr(xv,s,con,ncon,wd)
 
c     This routine draws contour lines within the quadrilateral cell
c     whose vertex coordinates are xv and variable values are s.
c     The maximum number of contours is ncon and the contour values
c     are con.
 
      real xv(4,2), s(4), con(*), x(4), y(4)
      include 'size.h'
      common /quad/ mark
      character*1 marker
 
 
c     Find all contour segments passing thru the area bounded
c     by the four vertices of the cell.
 
      aa  = 1./(ncon - 1)
      inc = max(1, (ncon - 1)/5)
 
      do 10 k=1,ncon
 
      nl = 0
      f1 = 0.
      f2 = 0.
      f3 = 0.
      f4 = 0.
      if(s(1) .le. con(k)) f1 = 1.
      if(s(2) .le. con(k)) f2 = 1.
      if(s(3) .le. con(k)) f3 = 1.
      if(s(4) .le. con(k)) f4 = 1.
 
c     If (f1+f2+f3+f4)=0 or =4, then contour does not pass through cell.
 
      if(abs(f1+f2+f3+f4-2.) .lt. 1.5) then
 
         mark = mark + 1
 
         call gclr(aa*(k-1))
 
         if (f1+f4 .eq. 1.) then
 
c           "left" border
 
            nl    = nl + 1
            fctr  = (con(k) - s(1))/(s(4)   -  s(1))
            x(nl) = xv(1,1) + fctr*(xv(4,1) - xv(1,1))
            y(nl) = xv(1,2) + fctr*(xv(4,2) - xv(1,2))
 
         endif
 
         if (f1+f2 .eq. 1.) then
 
c           "bottom" border
 
            nl    = nl + 1
            fctr  = (con(k) - s(1))/(s(2)   -  s(1))
            x(nl) = xv(1,1) + fctr*(xv(2,1) - xv(1,1))
            y(nl) = xv(1,2) + fctr*(xv(2,2) - xv(1,2))
 
         endif
 
         if (f2+f3 .eq. 1.) then
 
c           "right" border
 
            nl    = nl + 1
            fctr  = (con(k) - s(2))/(s(3)   -  s(2))
            x(nl) = xv(2,1) + fctr*(xv(3,1) - xv(2,1))
            y(nl) = xv(2,2) + fctr*(xv(3,2) - xv(2,2))
 
         endif
 
         if (f3+f4 .eq. 1.) then
 
c           "top" border
 
            nl    = nl + 1
            fctr  = (con(k) - s(4))/(s(3)   -  s(4))
            x(nl) = xv(4,1) + fctr*(xv(3,1) - xv(4,1))
            y(nl) = xv(4,2) + fctr*(xv(3,2) - xv(4,2))
 
         endif
 
         call gmova2(x(1),y(1))
         call glina2(x(2),y(2))
 
         if(k.eq.1+inc*0)  marker = 'L'
         if(k.eq.1+inc*1)  marker = '2'
         if(k.eq.1+inc*2)  marker = '4'
         if(k.eq.1+inc*3)  marker = '6'
         if(k.eq.1+inc*4)  marker = '8'
         if(k.eq.1+inc*5)  marker = 'H'
         if(mod(mark,mt+1).eq.1) call gmark(x(1),y(1),wd,marker)
 
      endif
 
 10   continue
 
      end
*dk sminmax
      subroutine sminmax(smin,smax,s)
 
c     This routine computes the minimum and maximum of the
c     scalar field s.
 
      include 'size.h'
      real s(*)
 
      smax = s(1)
      smin = s(1)
 
      do 10 ii=1,(mt+1)**2*10*(nr+1)
      smin = min(smin,s(ii))
      smax = max(smax,s(ii))
 10   continue
 
      end
*dk sphplot
      subroutine sphplot(v,s,pmap,titl,rshl,xn,w)
 
c     This routine generates plots of vector and/or scalar fields for
c     a spherical shell.  Required libraries are CFTMATH and CGSCFT.
c     If outlines of the continents are to be requested, files CMAP
c     and MAPDAT must be in the local file space.
 
      include 'size.h'
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
      common /fnam/ vname, sname, cname
      common /clbl/ tnorm, bnorm
      common /prty/ propr(20)
      real v(*), s(*), pmap(*), xn(*), w(*), rshl(129)
      real p1(3), p2(3), e(3)
      character*8 titl(4,4), vname, sname, cname
 
      nn = (mt + 1)**2*10
      nplate = 10
      vscale = 0.
 
      if(vname.ne.'        ') then
         irf  = 1
         if(ispec/2.eq.8) irf = 2
         irl  = nr + 1
         if(ispec/2.eq.8) irl = nr
         if(nskp.eq.0) nskp = nr
      endif
 
      if(sname.ne.'        ') then
         irf  = 1
         if(ispec/2.eq.1) irf = 2
         if(ispec/2.eq.4 .or. ispec/2.eq.8) irf = 2
         irl  = nr + 1
         if(ispec/2.eq.1) irl = nr
         if(ispec/2.eq.4 .or. ispec/2.eq.8) irl = nr
         if(nskp.eq.0 .or. nskp.eq.nr) nskp = irl - irf
      endif
 
      if(ispec/2.eq.5 .or. ispec/2.eq.6) then
         irf = 1
         irl = 1
      endif
 
      if(ispec/2.eq.7) then
         irf = 1
         irl = 2
         if(cname.ne.'        ') irl = 1
      endif
 
      if(nskp.lt.0) then
         irf = -nskp
         irl = -nskp
      endif
 
      irl = min(irl, irmax)
 
      call gscrn2(-2.25,1.5,-1.25,1.25)
      call gwind2(-2.25,1.5,-1.25,1.25)
      call gtwdth(0.050)
      call gtfnta
 
      itype = 1
      time  = propr(2)
      width = 0.0
      call gwidth(width)
      pi    = 2.*asin(1.)
      if(nequa.gt.0) dlng = 2.*pi/nequa
 
      if(iscl.eq.1) then
         if(mod(ispec,2).eq.1) call velscl(v,rshl,propr)
         if(ispec/2.eq.1.and.ispec.ne.5) call tempscl(s,propr,tnorm)
         call tradscl(time,rshl,propr)
      endif
 
      if(ispec/2.eq.8) call vradial(v,xn,s)
 
      if(isctn.gt.0) then
 
         dlong = 0.5*pi
         nsl   = isctn - 1
         if(isctn .eq. 4) dlong = 0.25*pi
         if(isctn .eq. 4) nsl   = nsl + 1
 
         do 10 isl=0,nsl
 
         angl  = (isl - 1)*dlong
         iang  = angl*180./pi
         iequ  = isl + 1
 
         if(ispec.ne.1) then
            if(iclr.eq.0) then
               call cntrslice(s,xn,rshl,w,iequ,angl,smin,smax)
            else
               call clrslice(s,xn,rshl,w,iequ,angl,smin,smax)
            endif
         endif
 
         if(mod(ispec,2).eq.1)
     &      call vslice(v,xn,rshl,w,iequ,angl,vscale)
 
         if(icptn .eq. 0) then
            call pframe0(titl,time,rshl,-isl,iang,vscale)
         else
            call pframe(titl,time,rshl,-isl,iang,vscale)
         endif
 
 10      continue
 
      endif
 
      do 40 ir=irf,irl,nskp
 
      if(ieqar.ge.1) then
 
         call gscrn2(-1.08,1.08,-0.88,0.56)
         call gwind2(-1.10,1.10,-0.88,0.56)
 
         if(ispec.ne.1) then
            if(iclr.ne.1) then
               call econtur(s,xn,w,ir,11,smin,smax,mt)
            else
               call eclrplt(s,xn,w,ir,smin,smax,mt)
            endif
         endif
 
         if(cname.ne.'        ' .and. ir.lt.nr/2) then
 
            do 22 k=1,nplate
            do 21 ii=1,(mt+1)**2*10
            w(ii) = 0.
            if(int(pmap(nn+ii)) .eq. k) w(ii) = 1.
 21         continue
            call econtur(w,xn,w((mt+1)**2*10+1),1,3,cmin,cmax,mt)
 22         continue
 
            if(ispec .eq. 14) call econtur(s,xn,w,1,2,cmin,cmax,mt)
 
         endif
 
         if(mod(ispec,2).eq.1 .and. ispec.ne.17)
     &      call evctplt(v,xn,ir,vscale,mt)
 
         call gwidth(width*0.5)
         if(imap.eq.1) call eqarmap
         call gwidth(width)
 
         if(icptn .eq. 0) then
            call eframe0(titl,time,rshl,ir,smin,smax,vscale)
         else
            call eframe(titl,time,rshl,ir,smin,smax,vscale)
         endif
 
         call gscrn2(-2.25,1.5,-1.25,1.25)
         call gwind2(-2.25,1.5,-1.25,1.25)
         call gtwdth(0.050)
 
      endif
 
      do 20  i=1,nequa
 
      rlng = dlng*(i-1) + reflng
      rlat = 0.
      iang = 57.296*rlng + 0.5
 
      call vupoint(rlng,rlat,p1,p2,e)
 
      if(ispec.ne.1) then
         if(iclr.ne.1) then
            call contour(s,xn,w,p1,p2,e,ir,11,smin,smax,mt)
         else
            call clrplt(s,xn,w,p1,p2,e,ir,smin,smax,mt)
         endif
      endif
 
      if(cname.ne.'        ' .and. ir.lt.nr/2) then
 
         do 25 k=1,nplate
         do 24 ii=1,(mt+1)**2*10
         w(ii) = 0.
         if(int(pmap(nn+ii)) .eq. k) w(ii) = 1.
 24      continue
         call contour(w,xn,w((mt+1)**2*10+1),p1,p2,e,1,3,cmin,cmax,mt)
 25      continue
 
         if(ispec .eq. 14) call contour(s,xn,w,p1,p2,e,1,2,cmin,cmax,mt)
 
      endif
 
      if(mod(ispec,2).eq.1)
     &   call vctplt(v,xn,p1,p2,e,ir,rshl,vscale,mt)
 
      call gwidth(width*0.5)
      if(imap.eq.1) call mapplot(p1,p2,e)
      call gwidth(width)
 
         if(icptn .eq. 0) then
            call pframe0(titl,time,rshl,ir,iang,vscale)
         else
            call pframe(titl,time,rshl,ir,iang,vscale)
         endif
 
 20   continue
 
      if(ipole.eq.1) then
 
         do 30 i=1,2
 
         if(i.eq.1) then
            rlng =  0.
            rlat  =  0.5*3.141592653589793
            iang  = -1
         else
            rlng =  0.
            rlat  = -0.5*3.141592653589793
            iang  = -2
         endif
 
         call vupoint(rlng,rlat,p1,p2,e)
 
         if(ispec.ne.1) then
            if(iclr.ne.1) then
               call contour(s,xn,w,p1,p2,e,ir,11,smin,smax,mt)
            else
               call clrplt(s,xn,w,p1,p2,e,ir,smin,smax,mt)
            endif
         endif
 
         if(cname.ne.'        ' .and. ir.lt.nr/2) then
 
         do 35 k=1,nplate
         do 34 ii=1,(mt+1)**2*10
         w(ii) = 0.
         if(int(pmap(nn+ii)) .eq. k) w(ii) = 1.
 34      continue
         call contour(w,xn,w((mt+1)**2*10+1),p1,p2,e,1,3,cmin,cmax,mt)
 35      continue
 
         if(ispec .eq. 14) call contour(s,xn,w,p1,p2,e,1,2,cmin,cmax,mt)
 
         endif
 
         if(mod(ispec,2).eq.1)
     &      call vctplt(v,xn,p1,p2,e,ir,rshl,vscale,mt)
 
         call gwidth(width*0.5)
         if(imap.eq.1) call mapplot(p1,p2,e)
         call gwidth(width)
 
         if(icptn .eq. 0) then
            call pframe0(titl,time,rshl,ir,iang,vscale)
         else
            call pframe(titl,time,rshl,ir,iang,vscale)
         endif
 
 30   continue
 
      endif
 
 40   continue
 
      end
*dk tempscl
      subroutine tempscl(t,propr,tnorm)
 
c     This routine scales the temperature field according
c     to the formula (t - tb(1))/(tmax - tb(1)).
 
      include 'size.h'
      real t(*), propr(20)
 
      if(propr(15).ne.0.) then
         tnorm = propr(15) - propr(14)
      else
         call sminmax(tmin,tmax,t)
         tnorm = tmax - propr(14)
      endif
 
      tnrm  = 1./tnorm
      do 10 ii=1,(mt+1)**2*10*(nr+1)
      t(ii) = tnrm*(t(ii) - propr(14))
 10   continue
 
      end
*dk tradscl
      subroutine tradscl(time,rshl,propr)
 
c     This routine scales the time in years by the factor
c     kappa/(d**2*3.1688e-8), where kappa is thermal diffusivity
c     and d is shell thickness.  It also normalizes the nodal
c     radii by the outer radius of the shell.
 
      include 'size.h'
      real rshl(*), propr(20)
 
      d    = rshl(1) - rshl(nr+1)
      time = time*propr(11)/(propr(7)*propr(12)*d**2*3.1688e-8)
 
      do 10 i=nr+1,1,-1
      rshl(i) = rshl(i)/rshl(1)
 10   continue
 
      end
*dk vctplt
      subroutine vctplt(v,xn,p1,p2,e,ir,rshl,scale,nt)
 
c     This routine generates a plot of the radial and tangential
c     components of the vector array v at the nodes of layer ir.
 
      real v(0:nt,nt+1,10,3,*), xn(0:nt,nt+1,10,3), rshl(*)
      real p1(3), p2(3), e(3), vr(3), vt(3)
 
c     The following limits the resolution to that of the nt = 8 grid.
 
      iskp  = nt/8
      arrw  = 0.2
 
      scale = vmaxir(v,ir)
 
      if( scale .eq. 0.0 )then
         call gmova2(-0.3,0.5)
         call gtext("FIELD IS NULL",13)
         return
      else
         vnorm = arrw/scale
      endif
 
      smll = 0.1*arrw
      smsq = smll**2
 
      do 30 id=1,10
      do 30 i2=1,nt,iskp
      i1b = iskp
      if((id.eq.1.or.id.eq.6) .and. i2.eq.1) i1b = 0
      do 30 i1=i1b,nt+1,iskp
 
      if(dotpr(e,xn,i1,i2,id,nt) .gt. 0.) then
 
c        Compute radial and tangential components of v.
 
         vrm = 0.
         do 10 j=1,3
         vrm = vrm + v(i1,i2,id,j,ir)*xn(i1,i2,id,j)
 10      continue
         do 20 j=1,3
         vr(j) = vnorm*vrm*xn(i1,i2,id,j)
         vt(j) = vnorm*v(i1,i2,id,j,ir) - vr(j)
 20      continue
 
c        Generate arrows proportional to radial and tangential
c        components projected onto plane defined by p1 and p2.
 
         xx  = dotpr(p1,xn,i1,i2,id,nt)
         yy  = dotpr(p2,xn,i1,i2,id,nt)
         dxr = dprd(p1,vr)
         dyr = dprd(p2,vr)
         dxt = dprd(p1,vt)
         dyt = dprd(p2,vt)
         if(dxr**2 + dyr**2.gt.smsq) call gvect(xx,yy,xx+dxr,yy+dyr)
         if(dxt**2 + dyt**2.gt.smsq) call gvect(xx,yy,xx+dxt,yy+dyt)
 
      endif
 
 30   continue
 
      call grgb(1.,1.,1.)
 
      call circle(0.,0.,1.)
      call equator(p1,p2,e)
 
      end
*dk velscl
      subroutine velscl(v,rshl,propr)
 
c     This routine scales the velocity field by the factor d/kappa,
c     where d is shell thickness and kappa is thermal diffusivity.
 
      include 'size.h'
      real v(*), rshl(*), propr(20)
 
      vscl = (rshl(1) - rshl(nr+1))*propr(7)*propr(12)/propr(11)
 
      do 10 i=1,(mt+1)**2*30*(nr+1)
      v(i) = vscl*v(i)
 10   continue
 
      end
*dk vmaxir
      function vmaxir(v,ir)
 
c     This routine finds the maximum amplitude value in layer ir
c     for the vector field v.
 
      include 'size.h'
      real v((mt+1)**2,10,3,*)
 
      vmax = 0.
 
      do 10 id=1,10
      do 10 ii=1,(mt+1)**2
      vmax = max(vmax, v(ii,id,1,ir)**2 + v(ii,id,2,ir)**2
     &               + v(ii,id,3,ir)**2)
 10   continue
 
      vmaxir = sqrt(vmax)
 
      end
*dk vradial
      subroutine vradial(u,xn,s)
 
c     This routine computes the radial component of the velocity
c     field u.
 
      include 'size.h'
      real u((mt+1)**2*10,3,*), xn((mt+1)**2*10,3), s((mt+1)**2*10,*)
 
      do ir=1,nr+1
         do ii=1,(mt+1)**2*10
            s(ii,ir) = xn(ii,1)*u(ii,1,ir) + xn(ii,2)*u(ii,2,ir)
     &               + xn(ii,3)*u(ii,3,ir)
         end do
      end do
 
      end
*dk vslice
      subroutine vslice(v,xn,rshl,w,iequ,theta,scale)
 
c     This routine generates a plot of the velocities on a
c     meridianal or equatorial slice of the spherical shell.
 
      include 'size.h'
      common /prty/ propr(20)
      real v(0:mt,mt+1,10,3,*), xn(0:mt,mt+1,10,3), rshl(*)
      real vsl(3*mt+1,2,nr+1), lat(3*mt+1)
 
c     Draw circles to define boundaries of spherical shell.
 
      call circle(0.,0.,1.)
      call circle(0.,0.,rshl(nr+1)/rshl(1))
 
      scale = 0.
      do ir=1,nr+1
         scale = max(scale,vmaxir(v,ir))
      end do
 
      iskpr = max(1, nr/16)
      iskpt = max(1, mt/16)
      arrw = 0.125
 
      if(scale .eq. 0.) then
         call gmova2(-0.3,0.5)
         call gtext("FIELD IS NULL",13)
         return
      else
         vnorm = arrw/scale
      endif
 
      smll = 0.1*arrw
      smsq = smll**2
      smll = 2.*smll
      nh   = mt/2
 
      if(iequ .eq. 1) then
 
c        Generate velocity plot on equatorial slice.
 
         do ir=1,nr+1,iskpr
            rr = rshl(ir)/rshl(1)
            do id=1,10
               do i=1,mt/2,mt/16
 
                  i1 = mt + 1 - i
                  i2 = nh + i
                  xx =  rr*xn(i1,i2,id,2)
                  yy = -rr*xn(i1,i2,id,1)
                  dx =  vnorm*v(i1,i2,id,2,ir)
                  dy = -vnorm*v(i1,i2,id,1,ir)
                  dz =  vnorm*v(i1,i2,id,3,ir)
 
                  if(dx**2+dy**2.gt.smsq) call gvect(xx,yy,xx+dx,yy+dy)
 
               end do
            end do
         end do
 
      else
 
c        Generate velocity plot on a 360 degree meridianal slice.
 
         do ihalf=1,2
 
            pi     = 2.*asin(1.)
            aa     = 1./rshl(1)
            sn     = 2*ihalf - 3
            theta0 = theta + (ihalf - 1)*pi
 
            call vmeridian(vsl,lat,v,xn,w,theta0,nr,mt)
 
            do i=1,3*mt+1,mt/16
               cosi = cos(lat(i))
               sini = sin(lat(i))
               do ir=1,nr+1,iskpr
 
                  rr = aa*rshl(ir)
                  xx = rr*cosi*sn
                  yy = rr*sini
                  dx = vnorm*vsl(i,1,ir)*sn
                  dy = vnorm*vsl(i,2,ir)
 
                  if(dx**2+dy**2.gt.smsq) call gvect(xx,yy,xx+dx,yy+dy)
 
               end do
            end do
         end do
 
      endif
 
      call grgb(1.,1.,1.)
 
      end
*dk vupoint
      subroutine vupoint(rlng,rlat,p1,p2,e)
 
      real p1(3), p2(3), e(3)
 
      p1(1) = -sin(rlng)
      p1(2) =  cos(rlng)
      p1(3) =  0.
      p2(3) =  cos(rlat)
       e(3) =  sin(rlat)
      p2(1) = -p1(2)*e(3)
      p2(2) =  p1(1)*e(3)
       e(1) =  p1(2)*p2(3)
       e(2) = -p1(1)*p2(3)
 
      end
*dk clrslice
      subroutine clrslice(s,xn,rshl,sl,iequ,theta,smin,smax)
 
c     This routine generates a color plot of the scalar field s
c     with blue at the low end and red at the high end of the
c     range of s for an equatorial slice if flag iequ .eq. 1 or
c     for a meridianal slice along longitude theta otherwise.
 
      include 'size.h'
      real s(0:mt,mt+1,10,*), xn(0:mt,mt+1,10,3), rshl(*)
      real sl(3*mt+1,*), lat(3*mt+1), sav(129), x(4), y(4)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         do ir=1,nr+1
            sav(ir) = s(0,1,1,ir) + s(0,1,6,ir)
            do id=1,10
               do i2=1,mt
                  do i1=1,mt
                     sav(ir) = sav(ir) + s(i1,i2,id,ir)
                  end do
               end do
            end do
            sav(ir) = sav(ir)/(10*mt*mt+2)
            do id=1,10
               do i2=1,mt+1
                  do i1=0,mt
                     s(i1,i2,id,ir) = s(i1,i2,id,ir) - sav(ir)
                  end do
               end do
            end do
         end do
      endif
 
      call sminmax(smin,smax,s)
 
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         smin = max(smin, -500.)
         smax = min(smax,  500.)
c        smin = -500.
c        smax =  500.
      endif
 
      sf = 1.0/(smax-smin)
      aa = 0.5/rshl(1)
      pi = 2.*asin(1.)
      nh = mt/2
 
      call legend(-1.9, -0.5, 1.0, smin, smax)
      call circle(0., 0., 1.)
      call circle(0., 0., rshl(nr+1)/rshl(1))
 
      if(iequ .eq. 1) then
 
c        Generate color plot of an equatorial slice.
 
         do ir=1,nr+1
 
            jr = max(1,    ir-1)
            kr = min(nr+1, ir+1)
            a1 = 0.5*aa*(rshl(jr) + rshl(ir))
            a2 = 0.5*aa*(rshl(kr) + rshl(ir))
 
            do id=1,10
               idll = mod(id+3, 5) + 6
               if(id .ge. 6) idll = id - 5
               do i=1,nh
 
                  i1   =  mt - i + 1
                  i2   =  nh + i
                  x(1) =  a1*(xn(i1,i2,id,2) + xn(i1+1,i2-1,id,2))
                  x(2) =  a1*(xn(i1,i2,id,2) + xn(i1-1,i2+1,id,2))
                  x(3) =  a2*(xn(i1,i2,id,2) + xn(i1-1,i2+1,id,2))
                  x(4) =  a2*(xn(i1,i2,id,2) + xn(i1+1,i2-1,id,2))
                  y(1) = -a1*(xn(i1,i2,id,1) + xn(i1+1,i2-1,id,1))
                  y(2) = -a1*(xn(i1,i2,id,1) + xn(i1-1,i2+1,id,1))
                  y(3) = -a2*(xn(i1,i2,id,1) + xn(i1-1,i2+1,id,1))
                  y(4) = -a2*(xn(i1,i2,id,1) + xn(i1+1,i2-1,id,1))
                  if(i .eq. 1) then
                     x(1) =  a1*(xn(i1,i2,id,2) + xn(nh+1,mt,idll,2))
                     x(4) =  a2*(xn(i1,i2,id,2) + xn(nh+1,mt,idll,2))
                     y(1) = -a1*(xn(i1,i2,id,1) + xn(nh+1,mt,idll,1))
                     y(4) = -a2*(xn(i1,i2,id,1) + xn(nh+1,mt,idll,1))
                  endif
 
                  call gclr(min(1.,max(0.,sf*(s(i1,i2,id,ir) - smin))))
 
                  call gplga2(x,y,4)
 
               end do
            end do
         end do
 
      else
 
c        Generate color plot of a 360 degree meridianal slice.
 
         do ihalf=1,2
 
            sn     = 2*ihalf - 3
            theta0 = theta + (ihalf - 1)*pi
 
            call meridian(sl,lat,s,xn,sl(1,nr+2),theta0,nr,mt)
 
            do i=1,3*mt+1
 
               j = max(1,      i-1)
               k = min(3*mt+1, i+1)
               cosj = cos(lat(j))
               cosk = cos(lat(k))
               sinj = sin(lat(j))
               sink = sin(lat(k))
 
               do ir=1,nr+1
 
               jr = max(1,    ir-1)
               kr = min(nr+1, ir+1)
               ro = aa*(rshl(jr) + rshl(ir))
               ri = aa*(rshl(kr) + rshl(ir))
               xx = sf*(sl(i,ir) - smin)
               xx = max(0.,xx)
               xx = min(1.,xx)
               call gclr(xx)
 
               x(1) = ro*cosj*sn
               x(2) = ri*cosj*sn
               x(3) = ri*cosk*sn
               x(4) = ro*cosk*sn
               y(1) = ro*sinj
               y(2) = ri*sinj
               y(3) = ri*sink
               y(4) = ro*sink
 
               call gplga2(x,y,4)
 
               end do
            end do
         end do
 
      endif
 
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         do ir=1,nr+1
            do id=1,10
               do i2=1,mt+1
                  do i1=0,mt
                     s(i1,i2,id,ir) = s(i1,i2,id,ir) + sav(ir)
                  end do
               end do
            end do
         end do
      endif
 
      call grgb(1.,1.,1.)
 
      end
*dk cntrslice
      subroutine cntrslice(s,xn,rshl,sl,iequ,theta,smin,smax)
 
c     This routine generates a contour plot of the scalar field s
c     with blue at the low end and red at the high end of the
c     range of s for an equatorial slice if flag iequ .eq. 1 or
c     for a meridianal slice along longitude theta otherwise.
 
      include 'size.h'
      real s(0:mt,mt+1,10,*), xn(0:mt,mt+1,10,3), rshl(*), con(21)
      real sl(3*mt+1,*), lat(3*mt+1), sav(129), xv(4,2), sc(4)
      common /splt/ ispec, iclr, iscl, isctn, ieqar,  ipole,
     &              nequa, nskp, irmax, imap, icptn, reflng, dtmovi
 
      ncon = 6
 
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         do ir=1,nr+1
            sav(ir) = s(0,1,1,ir) + s(0,1,6,ir)
            do id=1,10
               do i2=1,mt
                  do i1=1,mt
                     sav(ir) = sav(ir) + s(i1,i2,id,ir)
                  end do
               end do
            end do
            sav(ir) = sav(ir)/(10*mt*mt+2)
            do id=1,10
               do i2=1,mt+1
                  do i1=0,mt
                     s(i1,i2,id,ir) = s(i1,i2,id,ir) - sav(ir)
                  end do
               end do
            end do
         end do
      endif
 
      call sminmax(smin,smax,s)
 
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         smin = max(smin, -500.)
         smax = min(smax,  500.)
c        smin = -500.
c        smax =  500.
      endif
 
      call cntrlbl(smin,smax)
 
      ds = (smax - smin)/(ncon - 1)
      do i=1,ncon
         con(i) = smin + ds*(i - 1)
      end do
 
      aa = 1./rshl(1)
      pi = 2.*asin(1.)
      nh = mt/2
 
      call circle(0., 0., 1.)
      call circle(0., 0., rshl(nr+1)/rshl(1))
 
      wd = 0.030
      call gtwdth(wd)
 
      if(iequ .eq. 1) then
 
c        Generate contour plot of an equatorial slice.
 
         do ir=1,nr
            jr = ir + 1
            a1 = aa*rshl(ir)
            a2 = aa*rshl(jr)
            do id=1,10
               do i=1,nh
 
                  i1 =  mt - i + 1
                  i2 =  nh + i
                  xv(1,1) =  a1*xn(i1  ,i2  ,id,2)
                  xv(2,1) =  a1*xn(i1-1,i2+1,id,2)
                  xv(3,1) =  a2*xn(i1-1,i2+1,id,2)
                  xv(4,1) =  a2*xn(i1  ,i2  ,id,2)
                  xv(1,2) = -a1*xn(i1  ,i2  ,id,1)
                  xv(2,2) = -a1*xn(i1-1,i2+1,id,1)
                  xv(3,2) = -a2*xn(i1-1,i2+1,id,1)
                  xv(4,2) = -a2*xn(i1  ,i2  ,id,1)
                  sc(1)   =      s(i1  ,i2  ,id,ir)
                  sc(2)   =      s(i1-1,i2+1,id,ir)
                  sc(3)   =      s(i1-1,i2+1,id,jr)
                  sc(4)   =      s(i1  ,i2  ,id,jr)
 
                  call quadcntr(xv,sc,con,ncon,wd)
 
               end do
            end do
         end do
 
      else
 
c        Generate contour plot of a 360 degree meridianal slice.
 
         do ihalf=1,2
 
            sn     = 2*ihalf - 3
            theta0 = theta + (ihalf - 1)*pi
 
            call meridian(sl,lat,s,xn,sl(1,nr+2),theta0,nr,mt)
 
            do i=1,3*mt
               cosi = cos(lat(i))
               cosj = cos(lat(i+1))
               sini = sin(lat(i))
               sinj = sin(lat(i+1))
               do ir=1,nr
 
                  ro = aa*rshl(ir)
                  ri = aa*rshl(ir+1)
                  xv(1,1) = ro*cosi*sn
                  xv(2,1) = ri*cosi*sn
                  xv(3,1) = ri*cosj*sn
                  xv(4,1) = ro*cosj*sn
                  xv(1,2) = ro*sini
                  xv(2,2) = ri*sini
                  xv(3,2) = ri*sinj
                  xv(4,2) = ro*sinj
                  sc(1)   = sl(i  ,ir)
                  sc(2)   = sl(i  ,ir+1)
                  sc(3)   = sl(i+1,ir+1)
                  sc(4)   = sl(i+1,ir)
 
                  call quadcntr(xv,sc,con,ncon,wd)
 
               end do
            end do
         end do
 
      endif
 
      if(ispec/2.eq.1 .or. ispec/2.eq.4) then
         do ir=1,nr+1
            do id=1,10
               do i2=1,mt+1
                  do i1=0,mt
                     s(i1,i2,id,ir) = s(i1,i2,id,ir) + sav(ir)
                  end do
               end do
            end do
         end do
      endif
 
      call grgb(1.,1.,1.)
      call gtwdth(0.045)
 
      end
*dk meridian
      subroutine meridian(sl,lat,s,xn,coord,theta,nr,nt)
 
c     This routine computes the field values and latitude coordinates
c     for a longitude theta meridianal slice into the spherical shell
c     for the scalar field s.
 
      real  sl(3*nt+1,nr+1), s(0:nt,nt+1,10,nr+1), xn(0:nt,nt+1,10,3)
      real lat(3*nt+1),  coord(0:nt,nt+1,2)
 
c     Compute the latitude and longitude of the nodes in diamond one.
 
      do i2=1,nt+1
         do i1=0,nt
            coord(i1,i2,1) = asin(xn(i1,i2,1,3))
            coord(i1,i2,2) = atan(xn(i1,i2,1,2)
     &                          /(xn(i1,i2,1,1) + 1.e-20))
         end do
      end do
 
c     Find the diamond indices for the two diamonds containing the
c     meridian.
 
      pi = 2.*asin(1.)
      id = 2.5*(2.000001*pi + theta)/pi + 0.5
      id = mod(id+5, 5) + 1
      jd = 2.5*(2.000001*pi + theta)/pi
      jd = mod(jd+5, 5) + 6
 
c     Load the polar values in array sl.
 
      do ir=1,nr+1
         sl(     1,ir) = s(0,1,id,ir)
         sl(3*nt+1,ir) = s(0,1,jd,ir)
         lat(1)        =  0.5*pi
         lat(3*nt+1)   = -0.5*pi
      end do
 
c     Interpolate for the meridianal values in northern diamond.
 
      i1 = 1
      i2 = 1
      theta0 = mod(2.000001*pi + theta, 0.4*pi)
      if(theta0 .gt. 0.2*pi) theta0 = theta0 - 0.4*pi
      do i=2,2*nt
         if(i1.le.nt .and. i2.le.nt) then
            a1 = (coord(i1-1,i2+1,2) - theta0)/
     &           (coord(i1-1,i2+1,2) - coord(i1,i2,2))
            a2 = 1. - a1
            lat(i) =  a1*coord(i1,i2,1) + a2*coord(i1-1,i2+1,1)
            do ir=1,nr+1
               sl(i,ir) = a1*s(i1,i2,id,ir) + a2*s(i1-1,i2+1,id,ir)
            end do
            if(coord(i1,i2+1,2).gt.theta0 .and. i2.le.nt) then
               i1 = i1 + 1
            else
               i2 = i2 + 1
            end if
         end if
      end do
 
c     Interpolate for the meridianal values in southern diamond.
 
      i1 = 1
      i2 = 1
      theta0 = mod(2.200001*pi + theta, 0.4*pi)
      if(theta0 .gt. 0.2*pi) theta0 = theta0 - 0.4*pi
      do i=3*nt,nt,-1
         if(i1.le.nt .and. i2.le.nt) then
            a1 = (coord(i1-1,i2+1,2) - theta0)/
     &           (coord(i1-1,i2+1,2) - coord(i1,i2,2))
            a2 = 1. - a1
            lat(i) = -(a1*coord(i1,i2,1) + a2*coord(i1-1,i2+1,1))
            do ir=1,nr+1
               sl(i,ir) =  a1*s(i1,i2,jd,ir) + a2*s(i1-1,i2+1,jd,ir)
            end do
            if(coord(i1,i2+1,2).gt.theta0 .and. i2.le.nt) then
               i1 = i1 + 1
            else
               i2 = i2 + 1
            end if
         end if
      end do
 
      end
*dk vmeridian
      subroutine vmeridian(vsl,lat,v,xn,coord,theta,nr,nt)
 
c     This routine computes the field values and latitude coordinates
c     for a longitude theta meridianal slice into the spherical shell
c     for the vector field v.
 
      real vsl(3*nt+1,2,nr+1),  v(0:nt,nt+1,10,3,nr+1), lat(3*nt+1)
      real coord(0:nt,nt+1,2), xn(0:nt,nt+1,10,3), p(2)
 
c     Compute the direction of the intersection of the meridianal plane
c     with the equatorial plane.
 
      p(1) = cos(theta)
      p(2) = sin(theta)
 
c     Compute the latitude and longitude of the nodes in diamond one.
 
      do i2=1,nt+1
         do i1=0,nt
            coord(i1,i2,1) = asin(xn(i1,i2,1,3))
            coord(i1,i2,2) = atan(xn(i1,i2,1,2)
     &                          /(xn(i1,i2,1,1) + 1.e-20))
         end do
      end do
 
c     Find the diamond indices for the two diamonds containing the
c     meridian.
 
      pi = 2.*asin(1.)
      id = 2.5*(2.000001*pi + theta)/pi + 0.5
      id = mod(id+5, 5) + 1
      jd = 2.5*(2.000001*pi + theta)/pi
      jd = mod(jd+5, 5) + 6
 
c     Load the polar values in array vsl.
 
      do ir=1,nr+1
         vsl(     1,1,ir) = v(0,1,id,1,ir)*p(1) + v(0,1,id,2,ir)*p(2)
         vsl(     1,2,ir) = v(0,1,id,3,ir)
         vsl(3*nt+1,1,ir) = v(0,1,jd,1,ir)*p(1) + v(0,1,jd,2,ir)*p(2)
         vsl(3*nt+1,2,ir) = v(0,1,jd,3,ir)
         lat(1)        =  0.5*pi
         lat(3*nt+1)   = -0.5*pi
      end do
 
c     Interpolate for the meridianal values in northern diamond.
 
      i1 = 1
      i2 = 1
      theta0 = mod(2.000001*pi + theta, 0.4*pi)
      if(theta0 .gt. 0.2*pi) theta0 = theta0 - 0.4*pi
      do i=2,2*nt
         if(i1.le.nt .and. i2.le.nt) then
            a1 = (coord(i1-1,i2+1,2) - theta0)/
     &           (coord(i1-1,i2+1,2) - coord(i1,i2,2))
            a2 = 1. - a1
            lat(i) =  a1*coord(i1,i2,1) + a2*coord(i1-1,i2+1,1)
            do ir=1,nr+1
               vsl(i,1,ir) = (a1*v(i1  ,i2  ,id,1,ir)
     &                     +  a2*v(i1-1,i2+1,id,1,ir))*p(1)
     &                     + (a1*v(i1  ,i2  ,id,2,ir)
     &                     +  a2*v(i1-1,i2+1,id,2,ir))*p(2)
               vsl(i,2,ir) =  a1*v(i1  ,i2  ,id,3,ir)
     &                     +  a2*v(i1-1,i2+1,id,3,ir)
            end do
            if(coord(i1,i2+1,2).gt.theta0 .and. i2.le.nt) then
               i1 = i1 + 1
            else
               i2 = i2 + 1
            end if
         end if
      end do
 
c     Interpolate for the meridianal values in southern diamond.
 
      i1 = 1
      i2 = 1
      theta0 = mod(2.200001*pi + theta, 0.4*pi)
      if(theta0 .gt. 0.2*pi) theta0 = theta0 - 0.4*pi
      do i=3*nt,nt,-1
         if(i1.le.nt .and. i2.le.nt) then
            a1 = (coord(i1-1,i2+1,2) - theta0)/
     &           (coord(i1-1,i2+1,2) - coord(i1,i2,2))
            a2 = 1. - a1
            lat(i) = -(a1*coord(i1,i2,1) + a2*coord(i1-1,i2+1,1))
            do ir=1,nr+1
               vsl(i,1,ir) = (a1*v(i1  ,i2  ,jd,1,ir)
     &                     +  a2*v(i1-1,i2+1,jd,1,ir))*p(1)
     &                     + (a1*v(i1  ,i2  ,jd,2,ir)
     &                     +  a2*v(i1-1,i2+1,jd,2,ir))*p(2)
               vsl(i,2,ir) =  a1*v(i1  ,i2  ,jd,3,ir)
     &                     +  a2*v(i1-1,i2+1,jd,3,ir)
            end do
            if(coord(i1,i2+1,2).gt.theta0 .and. i2.le.nt) then
               i1 = i1 + 1
            else
               i2 = i2 + 1
            end if
         end if
      end do
 
      end
      block data bdgraphx
 
      common /clr1/ j1t(6), j2t(6), jet(6)
      data j1t/1,0,0,0,1,1/, j2t/0,0,0,-1,-1,-1/, jet/1,2,1,2,1,2/
 
      common /color/ red(41), grn(41), blu(41)
      data red/23*0.00, 0.10, 0.20, 0.30, 0.50, 0.70, 13*1.00/
      data grn/0.00, 0.00, 0.03, 0.06, 0.10, 0.14, 0.19, 0.25, 0.31,
     &         0.38, 0.46, 0.55, 0.65, 0.77, 0.90,    15*1.00,
     &         0.80, 0.60, 0.40, 0.30, 0.20, 0.10, 0.05, 4*0.00/
      data blu/17*1.00, 0.2, 0.10, 22*0.00/
 
      common /hxgn1/ j1e(6), j2e(6)
      data j1e/1,0,0,0,1,1/ j2e/0,0,0,-1,-1,-1/
 
      common /kntr1/ j1(4,2), j2(4,2)
      common /kntr2/ wid(3), ccon(3)
      common /kntr3/ cntrclr(3)
      data j1/0,-1,-1,0, 0,0,-1,0/, j2/0,1,0,0, 0,1,1,0/
      data wid/1., 1., 1./, ccon/0.60, 2.00, 3.00/
c     data wid/1., 1., 1./, ccon/0.80, 0.80, 1.10/
      data cntrclr/0.5, 0.75, 1.0/
 
      common /plrd1/ td(0:1), tt(0:1), tp(0:1), tv(0:1), te(0:1),
     &               ts(0:1), tk(0:1), tc(0:1), tu(0:1), tr(0:1),
     &               tq(0:1), th(0:1), tg(0:1), ta(0:1), tz(0:1)
      character*32 td, tt, tp, tv, te, ts, tk, tc, tu, tr, tq, th,
     &             tg, ta, tz
      data td/'density  (kg/m**3)              ',
     &        'normalized density              '/
      data tt/'temperature  (k)                ',
     &        'normalized temperature          '/
      data tp/'pressure  (pa)                  ',
     &        'pressure  (pa)                  '/
      data tv/'base 10 log of viscosity  (pa-s)',
     &        'base 10 log of viscosity        '/
      data te/'thermal expansion  (1/k)        ',
     &        'thermal expansion  (1/k)        '/
      data ts/'isovolume specific heat (j/kg-k)',
     &        'isovolume specific heat (j/kg-k)'/
      data tk/'isothermal bulk modulus  (pa)   ',
     &        'isothermal bulk modulus  (pa)   '/
      data tc/'thermal conductivity  (w/m-k)   ',
     &        'thermal conductivity  (w/m-k)   '/
      data tu/'rms tangential velocity  (cm/yr)',
     &        'rms tangential velocity         '/
      data tr/'rms radial velocity  (cm/yr)    ',
     &        'rms radial velocity             '/
      data tq/'radial heat conduction  (w)     ',
     &        'radial heat conduction          '/
      data th/'shear heating rate  (w/m**3)    ',
     &        'shear heating rate              '/
      data tg/'gruneisen gamma                 ',
     &        'gruneisen gamma                 '/
      data ta/'gravity acceleration (m/s**2)   ',
     &        'graviataional acceleration      '/
      data tz/'depth  (km)                     ',
     &        'normalized depth                '/
 
      common /plrd2/ premdep(20), premden(20)
      data premdep/2870., 2670., 2470., 2270., 2070., 1870.,
     &      1670., 1470., 1270., 1070.,  870.,  670.,  670.,
     &       550.,  400.,  400.,  220.,  115.,   24.,   24./
      data premden/5556., 5457., 5357., 5257., 5157., 5055.,
     &      4951., 4844., 4735., 4621., 4504., 4381., 3992.,
     &      3913., 3724., 3543., 3397., 3371., 3379., 2900./
 
      common /sect/ idia(6), jdia(6), imx(6), i10(6), i20(6),
     &              inc1(6), inc2(6)
      data idia/-1,-1, 0, 1, 2, 3/, jdia/ 1, 6, 6, 6, 1, 1/
      data i10 / 1, 0, 0, 1, 0, 0/, i20 / 0, 1, 1, 0, 1, 1/
      data inc1/ 0, 1, 1, 0, 1, 1/, inc2/ 1, 0,-1, 1, 0,-1/
      data imx / 2, 2, 1, 2, 2, 1/
 
      end
